<?php

namespace App\Http\Controllers;
use App\Models\Admin;
use App\Models\Agent;
use App\Models\Responder;
use App\Models\Accident_detection;

use Illuminate\Pagination\Paginator;
use Illuminate\Support\Collection;
use Illuminate\Pagination\LengthAwarePaginator;


use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use App\Mail\Sendotp;
use Illuminate\Support\Facades\Mail;
use JWTAuth;
use Config;
use Auth;
use Carbon\Carbon;
use Tymon\JWTAuth\Exceptions\JWTException;

class Adsresponders extends Controller
{
    
    public function create_responder(Request $request){
        
         $validator = Validator::make($request->all(), [
                'email' => 'required',
                'company_phone_number' => 'required',
                'company_address'=>'required',
                'company_name' => 'required',
                'nature_of_emergency'=>'required',
                'company_license'=>'required'
            ]);
            
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }
            
            $check = Responder::where("email", $request->email)->first();
            
            if($check){
                return response()->json(["message"=>"duplicate"], 400);
            }
            
            
                Responder::create([
                "email"=> $request->email,
                "company_phone_number"=> $request->company_phone_number,
                "company_address"=>$request->company_address,
                "company_name"=>$request->company_name,
                "nature_of_emergency"=>$request->nature_of_emergency,
                "password"=> Hash::make("plc1234#"),
                "company_license"=>$request->company_license
                ]);
          
           return response()->json(["message"=>"created"], 200);
            
            
    }
    
    //get responder
    
    public function get_responders(Request $request){
        
        $results = Responder::paginate(10);
        
        return response()->json($results, 200);
        
    }
    
    //update responder 
    
    public function update_responder(Request $request){
        $validator = Validator::make($request->all(), [
                'email' => 'required',
                'company_phone_number' => 'required',
                'company_address'=>'required',
                'company_name' => 'required',
                'nature_of_emergency'=>'required',
                'company_license'=>'required',
                'id'=>'required'
                
            ]);
            
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }
                
                if($request->password){
                    Responder::where("id",$request->id)->update([
                "email"=> $request->email,
                "company_phone_number"=> $request->company_phone_number,
                "company_address"=>$request->company_address,
                "company_name"=>$request->company_name,
                "nature_of_emergency"=>$request->nature_of_emergency,
                "password"=> Hash::make($request->password),
                "company_license"=>$request->company_license
                ]);
                }else{
                    Responder::where("id",$request->id)->update([
                "email"=> $request->email,
                "company_phone_number"=> $request->company_phone_number,
                "company_address"=>$request->company_address,
                "company_name"=>$request->company_name,
                "nature_of_emergency"=>$request->nature_of_emergency,
                "company_license"=>$request->company_license
                ]);
                }
            
               
          
           return response()->json(["message"=>"updated"], 200);
    }
    
    
    //responder details
     
    public function responder_details(Request $request){
        
                 $id = $request->query('id');
        
 $task_assigned = Accident_detection::where("responder_id", $id)->get();
        $admindetails = Responder::where("id",$id)->first();
        // $notifications = Accident_detection::where("closed_status", 0)->get();
        $closed_cases_count= Accident_detection::where("responder_id", $id)->where("closed_status", 1)->count();
        
        $closed_cases = Accident_detection::where("responder_id", $id)->where("closed_status", 1)->get();
        
         $task_assigned_count= Accident_detection::where("responder_id", $id)->count();
         
        $count = [
            "total_closed_task"=> $closed_cases_count,
            "task_assigned_count"=>$task_assigned_count
            ];
        
         return response()->json(["details"=>$admindetails,"records"=>$task_assigned, "closed_cases" => $closed_cases,"count"=>$count]);
    }
    
    
}