<?php

namespace App\Http\Controllers;
use App\Models\Admin;
use App\Models\Agent;
use App\Models\Responder;
use App\Models\Accident_detection;
use App\Models\Agent_failed_accepted_request_log;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Collection;
use Illuminate\Pagination\LengthAwarePaginator;


use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use App\Mail\Sendnotification;
use Illuminate\Support\Facades\Mail;
use JWTAuth;
use Config;
use Auth;
use Carbon\Carbon;
use Tymon\JWTAuth\Exceptions\JWTException;
class Agentcontroller extends Controller
{   
    
    
//create agent
public function create_agent (Request $request){
             $validator = Validator::make($request->all(), [
                'name' => 'required',
                'email'=> 'required',
                'phone_number'=> 'required'
            ]);
            
            
              if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }
            
            $check =  Agent::where("email", $request->email)->first();
            
            if($check){
                return response()->json(["message"=>"Agent Already exist"], 400);
            }
            Agent::create([
                'name'=> $request->name,
                'email'=> $request->email,
                'phone_number'=>$request->phone_number,
                'password'=>Hash::make("plc1234#")
                ]);
                
            return response()->json(["message"=>"success"], 200);
    }
   
   
       
//update agent
public function update_agent (Request $request){
             $validator = Validator::make($request->all(), [
                'name' => 'required',
                'email'=> 'required',
                'phone_number'=> 'required',
                'id'=>'required'
            ]);
            
            
              if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }
            
            Agent::where("id", $request->id)->update([
                'name'=> $request->name,
                'email'=> $request->email,
                'phone_number'=>$request->phone_number,
                'password'=>Hash::make("plc1234#")
                ]);
                
            return response()->json(["message"=>"success"], 200);
    } 
    
    //assign request to responder
    public function assign_accident (Request $request){
        
                $validator = Validator::make($request->all(), [
                'responderid' => 'required',
                'accident_id'=> 'required'
            ]);
            
            
              if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }
            
               $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                   $type=$token['role'];
            
            $getaccident = Accident_detection::where("id", $request->accident_id)->first();
            
            if($getaccident->request_accepted ==1 && $getaccident->agent_id == $id){
                $responder = Responder::where("id",$request->responderid)->first();
                
                $check_case = Accident_detection::where("responder_id", $request->responderid)->where("closed_status", 0)->first();
                
                if($check_case){
                    return response()->json(["message"=>"This responder currently on an active case"], 400);
                }
                   Accident_detection::where("id", $request->accident_id)->update([
                    "responder_id" => $request->responderid
                    ]);
                    
                 $title="ALLERT ACCIDENT CASE";
                     $responderinfo=[
                         "name"=>$responder->name,
                         "email"=>$responder->email
                         ];
                     $accident_details=[
                         "lat"=>$getaccident->lat,
                         "log"=>$getaccident->log
                         ];
                    $sendmail= Mail::to($responderinfo['email'])->send(new Sendnotification($title,$responderinfo,$accident_details));
                    
                    return response()->json(["message"=>"success"], 200);
            }else{ 
                return response()->json(["message"=>"Not allowed to assign to a responder"], 400);
            }
            
            
    }
    
    //view all agent
    
    public function get_all_agent(){
        $records = Agent::paginate(10);
        
         return response()->json($records, 200);
        
    }
    //get agent details 
    public function agent_details(Request $request){
          $agent_id = $request->query("id");
            
            
                  
                   
          if($agent_id){
              
          $agent_details = Agent::where("id", $agent_id)->first();
          $agent_unaccepted_logs = Agent_failed_accepted_request_log::where("agent_id",$agent_id)->get();
           $agent_unaccepted_device_logs = [];
          foreach($agent_unaccepted_logs as $data){
              $records = Accident_detection::where("id", $data->accident_detected_id)->first(); 
              
              $result = [
                  "device_id"=>$records->deviceid,
                  "date_assigned"=> $data->detected_date_time
                  ];
              array_push($agent_unaccepted_device_logs,  $result);
          }
          
          $closedcases = Accident_detection::where("agent_id", $agent_id)->where("closed_status", 1)->get();
          
          $attendedcases = Accident_detection::where("agent_id", $agent_id)->where("responder_id", ">", 0)->where("closed_status", 0)->get();
          $pendingcases = Accident_detection::where("agent_id", $agent_id)->where("request_accepted", ">", 0)->where("responder_id", 0)->get();
          
          //counts/////////////
          
          $agent_unaccepted_logs_count = Agent_failed_accepted_request_log::where("agent_id",$agent_id)->count();
          
           $closedcases_count = Accident_detection::where("agent_id", $agent_id)->where("closed_status", 1)->count();
          
          $attendedcases_count = Accident_detection::where("agent_id", $agent_id)->where("responder_id", ">", 0)->where("closed_status", 0)->count();
          $pendingcases_count = Accident_detection::where("agent_id", $agent_id)->where("request_accepted", ">", 0)->where("responder_id", 0)->count();
          
          
          //final result 
          
          $final_result = [
              "agent_details" =>$agent_details,
              "agent_unaccepted_logs"=>[
                  "data"=>$agent_unaccepted_logs,
                  "count"=>$agent_unaccepted_logs_count
                  ],
              "closedcases"=>[
                  "data"=>$closedcases,
                  "count"=>$closedcases_count
                  ],
                  
                "attendedcases"=>[
                  "data"=> $attendedcases,
                  "count"=> $attendedcases_count
                  ],
                  
                "pendingcases"=>[
                  "data"=>$pendingcases,
                  "count"=>$pendingcases_count
                  ],
              ];
          
           return response()->json($final_result, 200);
          }else{
              $token = JWTAuth::parseToken()->getPayload()->toArray();
               $agent_id=$token['id'];
                   $type=$token['role'];
                   
                   $agent_details = Agent::where("id", $agent_id)->first();
                   
                  if($type == "agent"){
                       $agent_unaccepted_logs = Agent_failed_accepted_request_log::where("agent_id",$agent_id)->get();
           $agent_unaccepted_device_logs = [];
          foreach($agent_unaccepted_logs as $data){
              $records = Accident_detection::where("id", $data->accident_detected_id)->first(); 
              
              $result = [
                  "device_id"=>$records->deviceid,
                  "date_assigned"=> $data->detected_date_time
                  ];
              array_push($agent_unaccepted_device_logs,  $result);
          }
          
          $closedcases = Accident_detection::where("agent_id", $agent_id)->where("closed_status", 1)->get();
          
          $attendedcases = Accident_detection::where("agent_id", $agent_id)->where("responder_id", ">", 0)->where("closed_status", 0)->get();
          $pendingcases = Accident_detection::where("agent_id", $agent_id)->where("request_accepted", ">", 0)->where("responder_id", 0)->get();
          
          //counts/////////////
          
          $agent_unaccepted_logs_count = Agent_failed_accepted_request_log::where("agent_id",$agent_id)->count();
          
           $closedcases_count = Accident_detection::where("agent_id", $agent_id)->where("closed_status", 1)->count();
          
          $attendedcases_count = Accident_detection::where("agent_id", $agent_id)->where("responder_id", ">", 0)->where("closed_status", 0)->count();
          $pendingcases_count = Accident_detection::where("agent_id", $agent_id)->where("request_accepted", ">", 0)->where("responder_id", 0)->count();
          
          
          //final result 
          
          $final_result = [
              "agent_details" =>$agent_details,
              "agent_unaccepted_logs"=>[
                  "data"=>$agent_unaccepted_logs,
                  "count"=>$agent_unaccepted_logs_count
                  ],
              "closedcases"=>[
                  "data"=>$closedcases,
                  "count"=>$closedcases_count
                  ],
                  
                "attendedcases"=>[
                  "data"=> $attendedcases,
                  "count"=> $attendedcases_count
                  ],
                  
                "pendingcases"=>[
                  "data"=>$pendingcases,
                  "count"=>$pendingcases_count
                  ],
              ];
          
           return response()->json($final_result, 200);
                  }
                   
          }
          
          return response()->json(["message"=>"An error occured"], 400);
    }
    
    
    
    //accept details 
    
    public function accept_request(Request $request){
                 $accident_id = $request->query("id");
                 
                  $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $agent_id=$token['id'];
                
                   
                 Accident_detection::where("id",$accident_id)->update(["agent_id"=>$agent_id]);
                 
                   return response()->json(["message"=>"accepted"], 200);
                 
    }
    
    
    
}









