<?php

namespace App\Http\Controllers;
use App\Models\Admin;
use App\Models\Agent;
use App\Models\Responder;
use App\Models\Accident_detection;
use App\Models\Device;
use App\Models\Agent_failed_accepted_request_log;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Collection;
use Illuminate\Pagination\LengthAwarePaginator;


use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use App\Mail\Sendotp;
use Illuminate\Support\Facades\Mail;
use JWTAuth;
use Config;
use Auth;
use Carbon\Carbon;
use Tymon\JWTAuth\Exceptions\JWTException;
class Authcontroller extends Controller
{
   
        
        public function login(Request $request)
        {
            $credentials = $request->only('email', 'password');
           
                 $result = [];
                foreach (['responder_api', 'agent_api', 'admin_api'] as $guard) {
                     if (Auth::guard($guard)->attempt($credentials)) {
                            $user=auth()->guard($guard)->user();
                    $payload=[
                        "name"=>$user->name,
                        "role"=>$user->type,
                        "id"=>$user->id
                        ];
                        
                    $token=JWTAuth::customClaims($payload)->fromUser($user);
                    
                    $data = ["token"=>$token, "type"=>$user->type];
                    
                    array_push($result, $data);
                    
                     }
                    
             
                }
                
                       if(empty($result)){
                        return response()->json(["message"=>"Invalid credential"]);
                    }
                    
                    return response()->json(["message"=>$result]);
          
            
        }
     
     //-----end-----

       
     
//search dashboard 
public function filter_dashboard($filter_type, $search_value){
   

      
        
     if($filter_type == "offline" || $filter_type == "online" && $search_value){
       
        
        
        
            $results = Device::where("status", $filter_type)->orWhere("device_id",  $search_value)->orWhere("device_number", $search_value)->orWhere("device_ime", $search_value)->orWhere("owner_name", $search_value)->orWhere("owner_phone_number", $search_value)->orWhere("owner_email", $search_value)->orWhere("vehicle_name", $search_value)->orWhere("vehicle_plate_number", $search_value)->orWhere("vehicle_model_year", $search_value)->orWhere("vehicle_chasses_number", $search_value)->paginate(10);
             
        
        
        return $results;
     }
        
         if($filter_type == "offline" || $filter_type == "online"){
             $results = Device::where("status", $filter_type)->paginate(10);
            
            return $results;
             
         }
     
     if($filter_type == "SOS" || $filter_type == "ACCIDENT DETECTED" || $filter_type == "Manual Scan"  && $search_value){
         
         
         
           $result = Accident_detection::where("agent_id", ">", 0)->where("nature_of_request", $filter_type)->where("deviceid", $search_value)->get();
           
         
         
         return $result;
     }
         
         
         if($filter_type == "SOS" || $filter_type == "ACCIDENT DETECTED" || $filter_type == "Manual Scan"){
             
               $result = Accident_detection::where("agent_id", ">", 0)->where("nature_of_request", $filter_type)->get();
             
             return $result;
             
         }
     
     if($filter_type == "pending_case"  && $search_value){
       
         
             $result = Accident_detection::where("request_accepted", ">", 0)->where("responder_id", 0)->where("deviceid", $search_value)->get();
         
         
         return $result;
     }
         
     
     
      if($filter_type == "pending_case"){
          
          $result = Accident_detection::where("request_accepted", ">", 0)->where("responder_id", 0)->get();
             
             return $result;
      }
      
      
     if($filter_type == "attended_case" && $search_value){
      
       
            $result = Accident_detection::where("agent_id", ">", 0)->where("responder_id", ">", 0)->where("closed_status", 0)->where("deviceid", $search_value)->get();
         
         return $result;
     }

if($filter_type == "attended_case"){
     $result = Accident_detection::where("agent_id", ">", 0)->where("responder_id", ">", 0)->where("closed_status", 0)->get();
              
              return $result;
}
     
     return [];
}
//user dashboard api
public function dashboard_api_for_user(Request $request){
     $searchvalue = $request->query('searchvalue');
     $filtertype = $request->query('filter_type');
     
     $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                   $type=$token['role'];
                   $accidents;
                   
                   
                   
                   $accidents = Accident_detection::where("agent_id", ">", 0)->where("closed_status", 0)->get();
                   
                  
                 
          
                $date = Carbon::now();
                $unaccepted_cases = Accident_detection::where("request_accepted", ">", 0)->where("responder_id", 0)->get();
                
                foreach($unaccepted_cases as $value){
                    
                    
                           if ($date->diffInSeconds($value->assigned_at) >= 60) {
                               
            $getagent;
            
            //take agent offline
          Agent::where("id", $value->agent_id)->update([
              "status"=>"offline"
              ]);
              
            //log failed acceptance
            Agent_failed_accepted_request_log::create([
                'accident_detected_id' => $value->id,
                'agent_id'=>$value->agent_id,
                'detected_date_time'=>$value->assigned_at
                ]);
            // Reassign request to another available agent
           $getagent = Agent::where("account_disabled", 1)->where("status","online")->inRandomOrder()->first();
           
           if(!$getagent){
                 $getagent = Agent::where("account_disabled", 1)->where("status","busy")->inRandomOrder()->first();
           }
    
            Accident_detection::where("id",$value->id )->update(['agent_id' => $getagent->id, 'assigned_at' => $date]);
        }
                }
                
        $onlinedevice = Device::where("status", "online")->count();
        $offlinedevice = Device::where("status", "offline")->count();
        $sos = Accident_detection::where("agent_id", ">", 0)->where("nature_of_request", "SOS")->count();
        
        $accident_detected = Accident_detection::where("agent_id", ">", 0)->where("nature_of_request", "ACCIDENT DETECTED")->count();
        
        $manualscan = Accident_detection::where("agent_id", ">", 0)->where("nature_of_request", "Manual Scan")->count();
        
        $pending_case = Accident_detection::where("request_accepted", ">", 0)->where("responder_id", 0)->count();
        
        $attended_case = Accident_detection::where("agent_id", ">", 0)->where("responder_id", ">", 0)->where("closed_status", 0)->count();
        
        $responders = Responder::count();
        
        $counts = [
            "onlinedevice"=>$onlinedevice,
            "offlinedevice"=>$offlinedevice,
            "sos"=>$sos,
            "accident_detected"=> $accident_detected,
            "manualscan"=>$manualscan,
            "pending_case"=>$pending_case,
            "attended_case"=>$attended_case,
            "responders "=>$responders 
            ];
    if($type == "admin"){
        
        $admindetails = Admin::where("id",$id)->first();
        
        if($searchvalue || $filtertype){
            $filtered_data = $this->filter_dashboard($filtertype,$searchvalue);
            
            return response()->json(["details"=>$admindetails, "records"=>$filtered_data,"notifications"=> $filtered_data, "counts"=>$counts]);
        }
        
         return response()->json(["details"=>$admindetails, "records"=>$accidents,"notifications"=> $accidents, "counts"=>$counts]);
    }
    
    
     if($type == "agent"){
          $notification = Accident_detection::where("agent_id", $id)->where("request_accepted", 0)->where("closed_status", 0)->get();
        $admindetails = Agent::where("id",$id)->first();
         
         if($searchvalue || $filtertype){
            $filtered_data = $this->filter_dashboard($filtertype,$searchvalue);
            
            return response()->json(["details"=>$admindetails, "records"=>$filtered_data,"notifications"=> $notification, "counts"=>$counts]);
        }
        
         return response()->json(["details"=>$admindetails, "records"=>$accidents,"notifications"=> $notification, "counts"=>$counts]);
    }
    
     if($type == "responder"){
          $task_assigned = Accident_detection::where("responder_id", $id)->get();
        $admindetails = Responder::where("id",$id)->first();
        // $notifications = Accident_detection::where("closed_status", 0)->get();
        $closed_cases_count= Accident_detection::where("responder_id", $id)->where("closed_status", 1)->count();
        
        $closed_cases = Accident_detection::where("responder_id", $id)->where("closed_status", 1)->get();
        
         $task_assigned_count= Accident_detection::where("responder_id", $id)->count();
         
        $count = [
            "total_closed_task"=> $closed_cases_count,
            "task_assigned_count"=>$task_assigned_count
            ];
        
         return response()->json(["details"=>$admindetails,"records"=>$task_assigned, "notifications"=> $task_assigned, "closed_cases" => $closed_cases,"count"=>$count]);
    }
    
     return response()->json(["message"=>"An error occured"]);
}




//update password from dashboard 
public function update_password_from_dashboard(Request $request){
               $validator = Validator::make($request->all(), [
                'password' => 'required|string|min:6|confirmed',
                'old_password'=>'required'
                
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                 $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                   
                 $user= User::where('id', $id)->first();
                $pass=$user->password;
                if(Hash::check($request->old_password, $pass)){
                    
                $id=$user->id;
           
            $admin = User::where('id',$id)->update([
                'password'=>Hash::make($request->password)
            ]);
            return response()->json(["status"=>"success"],200);
                }else{
                    return response()->json([
                        "satus"=> "failed",
                        "message"=>"Incorrect password"
                        ]);
                }
                
                }
}


        public function register_admin(Request $request)
        {
            $validator = Validator::make($request->all(), [
                'company_name' => 'required|string|max:255',
                'company_phone_number'=>'required',
                'state'=>'required',
                'email'=>'required|unique:users',
                'address'=>'required',
                'license'=>'required|mimes:pdf,png|max:10000',
                'passport_photo'=>'required|mimes:jpeg,webp,png,gif,jpg,svg|max:2048'
            ]);

            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                
                //upload license
                 $uniqueid=uniqid();
              $imgextention=$request->license->getClientOriginalExtension();
              
                //  $original_name=$request->image->getClientOriginalName();
                 $name=Carbon::now()->format('Ymd').'_'.$uniqueid.'.'.$imgextention;
                 
                 $file= $request->license->move(
                            public_path('license/'), $name
                        );
                        $base_url="https://pluralcodesandbox.com/obd_final_apis/public/license/";
                        $license=$base_url.$name;
                
                //upload passport photo
                $uniqueid2=uniqid();
                
                $imgextention2=$request->passport_photo->getClientOriginalExtension();
              
                 $name2=Carbon::now()->format('Ymd').'_'.$uniqueid2.'.'.$imgextention2;
                 
                 $file2= $request->passport_photo->move(
                            public_path('passport/'), $name2
                        );
                        $base_url2="https://pluralcodesandbox.com/obd_final_apis/public/passport/";
                        $passport=$base_url2.$name2;
                        
            $admin = Admin::create([
                'company_name' => $request->company_name,
                'company_phone_number'=>$request->company_phone_number,
                'state'=>$request->state,
                'email'=>$request->email,
                'address'=>$request->address,
                'license'=>$license,
                'passport_photo'=>$passport
            ]);

            

            return response()->json(["status"=>"success","message"=>"registeration successfull an email will be sent you when your account have been approved"],201);
            }
              
        }
        
    //register super admin
        public function register_superadmin(Request $request){
                    
            $validator = Validator::make($request->all(), [
                'name' => 'required|string|max:255',
                'email'=>'required',
                'phone_number'=>'required',
                'password'=>'required'
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                Superadmin::create([
                    'name'=> $request->name,
                    'email'=>$request->email,
                    'phone_number'=>$request->phone_number,
                    'role'=>"super_admin",
                    'password'=>Hash::make($request->password)
                    ]);
                    
                return response()->json([
                    "status"=>"success",
                    "message"=>"registeration successful"
                    ]);
            }
        }
        
        //login superadmin
        public function login_superadmin(Request $request){
                        $credentials = $request->only('email', 'password');
            try {
                auth()->shouldUse('super_admin');
                if(JWTAuth::attempt($credentials)){
                   $authuser=auth()->guard('super_admin')->user();
                 
                         $payload=[
                        "name"=>$authuser->company_name,
                        "role"=>$authuser->role,
                        "id"=>$authuser->id
                        ];
                        
                    $token=JWTAuth::customClaims($payload)->fromUser($authuser);
                   
                  
                }
                else {
                    return response()->json(['error' => 'invalid_credentials'], 400);
                }
            } catch (JWTException $e) {
                return response()->json(['error' => 'could_not_create_token'], 500);
            }

            return response()->json(["user"=>auth()->guard('super_admin')->user(),"token"=>$token]);
        }
        
        
        //dashboard api for super admin
        public function super_admin_dashboard(){
                   
                    $superadmin= Superadmin::first();
                    $total_amount_ordered = Orders::count();
                    $total_pending_delivery = Orders::where('delivery_status',"pending")->count();
                    
                     $total_orders= Orders::get();
                     $total_paid_orders= Orders::where('status',"paid")->get();
                     $total_unpaid_orders= Orders::where('status',"pending")->get();
                     $notification = Notification::orderBy('id','desc')->take(10)->get();
                     $total_unpaid_amount = 0;
                     foreach($total_unpaid_orders as $item3){
                            $total_product_price = (int)$item3->product_price * (int)$item3->amount_ordered;
                            
                            $total_commission_made = $total_product_price * $superadmin->super_admin_commission;
                            $total_unpaid_amount+= $total_product_price - $total_commission_made;
                     }
                     
                     $total_paid_amount = 0;
                     foreach($total_paid_orders as $item2){
                            $total_product_price = (int)$item2->product_price * (int)$item2->amount_ordered;
                            
                            $total_commission_made = $total_product_price * $superadmin->super_admin_commission;
                            $total_paid_amount+= $total_product_price - $total_commission_made;
                     }
                     $total_amount_made = 0;
                     foreach($total_orders as $item){
                            $total_product_price = (int)$item->product_price * (int)$item->amount_ordered;
                            
                            $total_amount_made += $total_product_price * $superadmin->super_admin_commission;
                            
                     }
                    
                    $total_customers = User::count();
                    $total_sellers_on_the_platform = Admin::count();
                    $total_products_uploaded = Products::count();
                    
                    $final_result = [
                         "super_admin_name"=>$superadmin->name,
                         "super_admin_email"=>$superadmin->email,
                         "super_admin_secret_question"=>$superadmin->secret_question,
                         "phone_number"=>$superadmin->phone_number,
                         "total_amount_ordered"=>$total_amount_ordered,
                         "total_pending_delivery"=>$total_pending_delivery,
                         "total_customers"=>$total_customers,
                         "total_sellers_on_the_platform"=>$total_sellers_on_the_platform,
                         "total_products_uploaded"=> $total_products_uploaded,
                         "total_amount_made"=>$total_amount_made,
                         "total_unpaid_amount"=>$total_unpaid_amount,
                         "total_paid_amount"=>$total_paid_amount,
                         "notification"=>$notification
                        ];
                        
                    return response()->json($final_result);
                    
        }
        //superadmin_logout
        public function logout_super_admin(){
            auth()->guard('super_admin')->logout();
            
            return response()->json([
                "status"=>"success"
                ]);
        }
        //update super admin details
        public function confirm_superadmin_email(Request $request){
               $email = $request->email;
           
                $superadmin_details= Superadmin::where('email',$email)->first();
              
                if($superadmin_details){
                    $otp_gen=random_int(1000, 9999);
                     
                    $carbondate=Carbon::now();
                    //Foo::whereBetween('created_at', [now()->subMinutes(3), now()])->get()
                    $datetime= $carbondate->toDateTimeString();
   
                    
                    Superadmin::where('email',$email)->update([
                        "otp"=>$otp_gen,
                        "otp_date"=>$datetime
                        ]);
                     $title="otp from market for opticals";
                     $customer_info=[
                         "name"=>$superadmin_details->name,
                         "email"=>$superadmin_details->email
                         ];
                     $otp=[
                         "otp"=>$otp_gen
                         ];
                    $sendmail= Mail::to( $customer_info['email'])->send(new Sendotp($title,$customer_info,$otp));
                   
                    if(empty($sendmail)){
                      return response()->json([
                     "status"=>"success",
                   
                     "message"=>"user exist"
                    ]);
                    }
                    
                }else{
                    
                    return response()->json([
                        "status"=>"failed",
                        "message"=>"user does not exist"
                        
                        ]);
                }
        }
        
        
        
        
        
        //super admin confirm otp
        public function super_admin_confirm_otp(Request $request){
                 $validator = Validator::make($request->all(),[
                'email' => 'required|string|email|max:255',
                'otp'=>'required'
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                 $otp=$request->otp;
                $email=$request->email;
                    $carbondate=Carbon::now();
                    $otp_check=Superadmin::where('email',$email)->where('otp',$otp)->where('otp_date', '>', $carbondate->subMinutes(5)->format('Y-m-d H:i:s'))->first();
                  
                    if($otp_check){
                        return response()->json([
                            "status"=>"success",
                            "message"=>"otp verified"
                            ]);
                      
                    }else{
                           return response()->json([
                            "status"=>"failed",
                            "message"=>"otp expired"
                            ]);
                    } 
            }
        }
        //update superadmin password
        public function update_super_admin_pass(Request $request){
                            $validator = Validator::make($request->all(),[
                'password' => 'required',
                'email'=>'required'
              ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                 $superadmin = Superadmin::first();
                         $email=$superadmin->email;
                         Superadmin::where('email',$email)->update([
                             "password"=>Hash::make($request->password)
                             ]);
                            return response()->json(["status"=>"success"]);
            }
                        
        }
        //super admin set security questions
        public function set_securityquestion_and_answer(Request $request){
                   $security_question = $request->security_question;
                   $security_answer = $request->security_answer;
                   if($security_question && $security_answer){
                        $super_admin = Superadmin::first();
                    $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                   Superadmin::where('id',$id)->update([
                       "secret_question"=>$security_question,
                       "secret_answer"=> $security_answer
                       ]);
                       
                       return response()->json([
                           "status"=>"success"
                           ]);
                   }
                  
        }
        //super admin check security questions and answer
        public function check_security_question(Request $request){
                         $security_answer = $request->security_answer;
                         $super_admin= Superadmin::first();
                         $answer=$super_admin->secret_answer;
                         
                         
                         if($security_answer == $answer){
                             return response()->json([
                                 "status"=>"success"
                                 ]);
                         }else{
                              return response()->json([
                                 "status"=>"failed"
                                 ]);
                         }
        }
        //super admin update email
        public function superadmin_update_email(Request $request){
             $token = JWTAuth::parseToken()->getPayload()->toArray();
                $id=$token['id'];
                      $email=$request->email;
                      $secret_answer= $request->secret_answer;
                      
                      
                      if(empty($email)){
                         
                        return response()->json([
                            "status"=>"failed",
                            "message"=>"email field required"
                            ]);
                      }else{
                          $confirm_secret_answer = Superadmin::where('secret_answer',$secret_answer)->first();
                          if($confirm_secret_answer){
                              Superadmin::where('id',$id)->update([
                              "email"=>$email,
                              ]);
                                return response()->json([
                            "status"=>"success",
                            "message"=>"email updated"
                            ]);
                          }
                           
                      }
        }
        
          public function superadmin_name_phonenumber(Request $request){
             $token = JWTAuth::parseToken()->getPayload()->toArray();
                $id=$token['id'];
                      $name=$request->name;
                       $phone_number=$request->phone_number;
                      if(empty($name) && empty($phone_number)){
                         
                        return response()->json([
                            "status"=>"failed",
                            "message"=>"email field required"
                            ]);
                      }else{
                           Superadmin::where('id',$id)->update([
                              "name"=>$name,
                              "phone_number"=>$request->phone_number
                              ]);
                                return response()->json([
                            "status"=>"success",
                            "message"=>"email updated"
                            ]);
                      }
        }
        //update super admin details end
        
    //update admin details
           public function update_admin_details(Request $request)
        {
            $validator = Validator::make($request->all(), [
                'company_name' => 'required|string|max:255',
                'company_phone_number'=>'required',
                'state'=>'required',
                'email'=>'required',
                'address'=>'required',
                'license'=>'required|mimes:pdf,png|max:10000',
                'passport_photo'=>'required|mimes:jpeg,webp,png,gif,jpg,svg|max:2048'
            ]);

            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                $token = JWTAuth::parseToken()->getPayload()->toArray();
                $id=$token['id'];
                if($request->hasFile('license') && $request->hasFile('passport_photo')){
                        //upload license
                 $uniqueid=uniqid();
              $imgextention=$request->license->getClientOriginalExtension();
              
                //  $original_name=$request->image->getClientOriginalName();
                 $name=Carbon::now()->format('Ymd').'_'.$uniqueid.'.'.$imgextention;
                 
                 $file= $request->license->move(
                            public_path('license/'), $name
                        );
                        $base_url="https://codesandbox.com.ng/market_for_optical/public/license/";
                        $license=$base_url.$name;
                
                //upload passport photo
                $uniqueid2=uniqid();
                
                $imgextention2=$request->passport_photo->getClientOriginalExtension();
              
                 $name2=Carbon::now()->format('Ymd').'_'.$uniqueid2.'.'.$imgextention2;
                 
                 $file2= $request->passport_photo->move(
                            public_path('passport/'), $name2
                        );
                        $base_url2="https://codesandbox.com.ng/market_for_optical/public/passport/";
                        $passport=$base_url2.$name2;
                        
            $admin = Admin::where('id',$id)->update([
                'company_name' => $request->company_name,
                'company_phone_number'=>$request->company_phone_number,
                'state'=>$request->state,
                'email'=>$request->email,
                'address'=>$request->address,
                'active'=>false,
                'license'=>$license,
                'passport_photo'=>$passport
            ]);

            

            return response()->json(["status"=>"success"],201);
                }elseif($request->hasFile('license')){
                            //upload license
                 $uniqueid=uniqid();
              $imgextention=$request->license->getClientOriginalExtension();
              
                //  $original_name=$request->image->getClientOriginalName();
                 $name=Carbon::now()->format('Ymd').'_'.$uniqueid.'.'.$imgextention;
                 
                 $file= $request->license->move(
                            public_path('license/'), $name
                        );
                        $base_url="https://codesandbox.com.ng/market_for_optical/public/license/";
                        $license=$base_url.$name;
                
            
            $admin = Admin::where('id',$id)->update([
                'company_name' => $request->company_name,
                'company_phone_number'=>$request->company_phone_number,
                'state'=>$request->state,
                'email'=>$request->email,
                'address'=>$request->address,
                'license'=>$license,
                'active'=>false,
                'passport_photo'=>$request->passport_photo
            ]);

            

            return response()->json(["status"=>"success"],201);
                    
                    
                }elseif($request->hasFile('passport_photo')){
                         
                //upload passport photo
                $uniqueid2=uniqid();
                
                $imgextention2=$request->passport_photo->getClientOriginalExtension();
              
                 $name2=Carbon::now()->format('Ymd').'_'.$uniqueid2.'.'.$imgextention2;
                 
                 $file2= $request->passport_photo->move(
                            public_path('passport/'), $name2
                        );
                        $base_url2="https://codesandbox.com.ng/market_for_optical/public/passport/";
                        $passport=$base_url2.$name2;
                        
            $admin = Admin::where('id',$id)->update([
                'company_name' => $request->company_name,
                'company_phone_number'=>$request->company_phone_number,
                'state'=>$request->state,
                'email'=>$request->email,
                'address'=>$request->address,
                'active'=>false,
                'license'=>$request->license,
                'passport_photo'=>$passport
            ]);

            

            return response()->json(["status"=>"success"],201);
                }else{
            $admin = Admin::where('id',$id)->update([
                'company_name' => $request->company_name,
                'company_phone_number'=>$request->company_phone_number,
                'state'=>$request->state,
                'email'=>$request->email,
                'address'=>$request->address,
                'license'=>$request->license,
                'passport_photo'=>$request->passport_photo
            ]);

            

            return response()->json(["status"=>"success"],201);
                }
            
            }
              
        }
        //update admin/seller password
         //update  admin details
        public function confirm_admin_email(Request $request){
               $email = $request->email;
           
                $admin_details= Admin::where('email',$email)->first();
              
                if($admin_details){
                    $otp_gen=random_int(1000, 9999);
                     
                    $carbondate=Carbon::now();
                    //Foo::whereBetween('created_at', [now()->subMinutes(3), now()])->get()
                    $datetime= $carbondate->toDateTimeString();
   
                    
                    Admin::where('email',$email)->update([
                        "otp"=>$otp_gen,
                        "otp_date"=>$datetime
                        ]);
                     $title="otp from market for opticals";
                     $customer_info=[
                         "name"=>$admin_details->name,
                         "email"=>$admin_details->email
                         ];
                     $otp=[
                         "otp"=>$otp_gen
                         ];
                    $sendmail= Mail::to( $customer_info['email'])->send(new Sendotp($title,$customer_info,$otp));
                   
                    if(empty($sendmail)){
                      return response()->json([
                     "status"=>"success",
                     "message"=>"user exist"
                    ]);
                    }
                    
                }else{
                    return response()->json([
                        "status"=>"failed",
                        "message"=>"user does not exist"
                        
                        ]);
                }
        }
        //admin/seller confirm otp
        public function admin_confirm_otp(Request $request){
                 $validator = Validator::make($request->all(),[
                'email' => 'required|string|email|max:255',
                'otp'=>'required'
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                 $otp=$request->otp;
                $email=$request->email;
                    $carbondate=Carbon::now();
                   
                    $otp_check=Admin::where('email',$email)->where('otp',$otp)->where('otp_date', '>', $carbondate->subMinutes(5)->format('Y-m-d H:i:s'))->first();
                  
                    if($otp_check){
                        return response()->json([
                            "status"=>"success",
                            "message"=>"otp verified"
                            ]);
                        
                    }else{
                        return response()->json([
                            "status"=>"failed",
                            "message"=>"otp expired"
                            ]); 
                    } 
            }
        }
        
        public function admin_update_password(Request $request){
                        $validator = Validator::make($request->all(), [
                        'password' => 'required|string|min:6|confirmed',
                        'email'=> 'required'
                        ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                       User::where('email',$request->email)->update([
                             "password"=> Hash::make($request->password)
                           ]);
                           
                 return response()->json([
                     "status"=>"success"
                     ]);
            }
        }
//admin dashboard api
public function admin_dashboard_api(){
          $token = JWTAuth::parseToken()->getPayload()->toArray();
          $id=$token['id'];
          $carbondate=Carbon::now();
          $admin=   Admin::where('id',$id)->first();
          $date= $carbondate->toDateString();
          $total_product_uploaded= Products::where('owner_id',$id)->count();
          $total_orders_made_perday = Orders::where('owner_id',$id)->where('date',$date)->count();
          $total_pending_order= Orders::where('owner_id',$id)->where('status',"pending")->count();
          $total_unaproved_products=Products::where('owner_id',$id)->where('product_aprove_status',false)->count();
          $total_aproved_products=Products::where('owner_id',$id)->where('product_aprove_status',true)->count();
          $admin_notification = Notification::where('owner_id',$id)->orderBy('id','desc')->take(10)->get();
          
          
          return response()->json([
              "admin"=>$admin,
              "total_product_uploaded"=>$total_product_uploaded,
              "total_orders_made_perday"=>$total_orders_made_perday,
              "total_pending_order"=>$total_pending_order,
              "total_unaproved_products"=>$total_unaproved_products,
              "total_aproved_products"=>$total_aproved_products,
               "notifications"=>$admin_notification
              
              ]);
}


//logout admin
 public function adminlogout(){
      auth()->guard('admin_api')->logout();
      
      return response()->json([
          "status"=>"success"
          ]);
 }
 //logout customer
 public function customerlogout(){
     auth()->user()->logout();
     
      return response()->json([
          "status"=>"success"
          ]);
 }
 
public function user_confirm_email(Request $request){
    
            $validator = Validator::make($request->all(),[
                'email' => 'required|string|email|max:255',
                
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                $email=$request->email;
                $user_details= User::where('email',$email)->first();
              
                if($user_details){
                    $otp_gen=random_int(1000, 9999);
                     
                    $carbondate=Carbon::now();
                    //Foo::whereBetween('created_at', [now()->subMinutes(3), now()])->get()
                    $datetime= $carbondate->toDateTimeString();
   
                    
                    User::where('email',$email)->update([
                        "otp"=>$otp_gen,
                        "otp_date_time"=>$datetime
                        ]);
                     $title="otp from obd2";
                     $customer_info=[
                         "name"=>$user_details->name,
                         "email"=>$user_details->email
                         ];
                     $otp=[
                         "otp"=>$otp_gen
                         ];
                    $sendmail= Mail::to( $customer_info['email'])->send(new Sendotp($title,$customer_info,$otp));
                   
                    if(empty($sendmail)){
                      return response()->json([
                     "status"=>"success",
                     "email"=> $user_details->email,
                     "message"=>"user exist"
                    ]);
                    }
                    
                }else{
                    
                    return response()->json([
                        "status"=>"failed",
                        "message"=>"user does not exist"
                        
                        ]);
                }
               
                
            }
        
}
//verify otp
public function user_verify_otp(Request $request){
    
            $validator = Validator::make($request->all(),[
                'email' => 'required|string|email|max:255',
                'otp'=>'required'
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                 $otp=$request->otp;
                $email=$request->email;
                    $carbondate=Carbon::now();
                    $otp_check=User::where('email',$email)->where('otp',$otp)->where('otp_date_time', '>', $carbondate->subMinutes(5)->format('Y-m-d H:i:s'))->first();
                  
                    if($otp_check){
                         return response()->json([
                            "status"=>"success",
                            "message"=>"otp verified"
                            ]);
                        
                    }else{
                        return response()->json([
                            "status"=>"failed",
                            "message"=>"otp expired"
                            ]);
                    } 
            }
              
}
//reset password
  public function  user_reset_password(Request $request){
                $validator = Validator::make($request->all(), [
                'email'=>'required',
                'password' => 'required|string|min:6|confirmed'
            ]);

            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                $email=$request->email;
                User::where('email',$email)->update([
                    "password"=> Hash::make($request->get('password')),
                    ]);
                    
                return response()->json([
                    "status"=>"success",
                    "message"=>"updated successfully"
                    ]);
            }
  }
//
   public function update_shipping_address(Request $request){
            $validator = Validator::make($request->all(), [
                'state' => 'required',
                'shipping_address'=>'required'
            ]);

            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                
                 $token = JWTAuth::parseToken()->getPayload()->toArray();
                $id=$token['id'];
                
                User::where('id',$id)->update([
                      "state"=>$request->state,
                      "destination_address"=>$request->shipping_address
                    ]);
                    
                return response()->json([
                    "status"=>"success",
                    
                    ]);
            }
                   
   }
//  'email'=>'required|string|email|max:255|unique:users,email,'.$id

//update customers details
    public function update_details(Request $request){
         $token = JWTAuth::parseToken()->getPayload()->toArray();
                $id=$token['id'];
                $validator = Validator::make($request->all(), [
                'name'=>'required',
                'country'=>'required',
                'phone_number'=>'required',
                'state' => 'required',
                'shipping_address'=>'required'
            ]);

            if($validator->fails()){
                    return response()->json(["status"=>"failed","message"=>"all fields are required "], 400);
            }else{
               
                
                User::where('id',$id)->update([
                    "name"=>$request->name,
                    "country"=>$request->country,
                    "phone_number"=>$request->phone_number,
                    "state"=>$request->state,
                    "destination_address"=>$request->shipping_address
                    ]);
                    
                return response()->json([
                    "status"=>"success"
                    ]);
            }
    }

    
     public function paginate($items, $perPage = 5, $page = null, $options = [])
    {
        $page = $page ?: (Paginator::resolveCurrentPage() ?: 1);
        $items = $items instanceof Collection ? $items : Collection::make($items);
        return new LengthAwarePaginator($items->forPage($page, $perPage), $items->count(), $perPage, $page, $options);
    }
    
     //superadmin global search variable
    public function super_admin_search_api(Request $request){
                 $page_type=$request->page_type;
                 $search_query = $request->query_data;
                 if($page_type == "product_page"){
                          if(is_numeric($search_query)){
                              
                                $products = Products::where('id',$search_query)->paginate(10)->toArray();
                $product_array=array();
                foreach($products['data'] as $product){
                        $product_id=$product["id"];
                        $product_image= Sub_product::where('product_id',$product_id)->first();
                        $image_url=$product_image->image_url;
                        $product_order_count=Orders::where('product_id',$product_id)->count();
                        $product_amount_made= Orders::where('product_id',$product_id)->sum('product_price');
                        $date_time_created= $product["created_date"].','.$product["created_time"];
                        $aprove_status= "";
                        if($product["product_aprove_status"] == true){
                           $aprove_status= "Approved";
                        }else{
                            $aprove_status= "Not Approved";
                        }
                        $product_list=[
                             "id"=>$product["id"],
                            "product_name"=>$product["product_name"],
                            "product_price"=>$product["product_price"],
                            "product_image"=>$image_url,
                            "product_stock"=>$product["stock"],
                            "approved_status"=>$aprove_status,
                            "product_amount_sold"=> $product_order_count,
                            "product_amount_made"=> $product_amount_made,
                            "date_time"=>$date_time_created,
                            "product_stock_quantity"=> $product["product_quantity"]
                            ];
                        array_push($product_array, $product_list);
                }
                           return response()->json(["type"=>"product_page","product_array"=>$product_array]);
                          }else{
                        $products = Products::where('product_name','LIKE', "%{$search_query}%")->paginate(10)->toArray();
                $product_array=array();
                foreach($products['data'] as $product){
                        $product_id=$product["id"];
                        $product_image= Sub_product::where('product_id',$product_id)->first();
                        $image_url=$product_image->image_url;
                        $product_order_count=Orders::where('product_id',$product_id)->count();
                        $product_amount_made= Orders::where('product_id',$product_id)->sum('product_price');
                        $date_time_created= $product["created_date"].','.$product["created_time"];
                        $aprove_status= "";
                        if($product["product_aprove_status"] == true){
                           $aprove_status= "Approved";
                        }else{
                            $aprove_status= "Not Approved";
                        }
                        $product_list=[
                             "id"=>$product["id"],
                            "product_name"=>$product["product_name"],
                            "product_price"=>$product["product_price"],
                            "product_image"=>$image_url,
                            "product_stock"=>$product["stock"],
                            "approved_status"=>$aprove_status,
                            "product_amount_sold"=> $product_order_count,
                            "product_amount_made"=> $product_amount_made,
                            "date_time"=>$date_time_created,
                            "product_stock_quantity"=> $product["product_quantity"]
                            ];
                        array_push($product_array, $product_list);
                }
                       return response()->json(["type"=>"product_page","product_array"=>$product_array]);
                   
                          }
                 }elseif($page_type == "order_page"){
                      if(is_int($search_query)){
                           $order_list= Orders::where('id',$search_query)->orderBy('id','desc')->get()->groupBy('customer_id');
            
            $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          $filtered_data=[];
            foreach($arrayvalue as $date8){
                foreach($date8 as $test2=>$test3){
                    $test5= $test3->groupBy('time');
                array_push($filtered_data , $test5);
                }
               
            }
            $final_result =[];
             foreach($filtered_data as $value_data){
                foreach($value_data as $test21=>$test22){
                    foreach($test22 as $test24){
                         $array6=["customer_name"=> $test24->customer_name,"delivery_status"=>$test24->delivery_status,"date"=>$test24->date,"customer_id"=>$test24->customer_id,"time"=>$test24->time];
                         array_push($final_result, $array6);
                         break;
                    }
                }
            }
                $paginate_data = $this->paginate($final_result);
               return response()->json(["type"=>"order_page","paginate_data"=>$paginate_data]);
                      } else{
                            $order_list= Orders::where('customer_name','LIKE', "%{$search_query}%")->orderBy('id','desc')->get()->groupBy('customer_id');
            
            $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          $filtered_data=[];
            foreach($arrayvalue as $date8){
                foreach($date8 as $test2=>$test3){
                    $test5= $test3->groupBy('time');
                array_push($filtered_data , $test5);
                }
                  
                
            }
            $final_result =[];
             foreach($filtered_data as $value_data){
                foreach($value_data as $test21=>$test22){
                    foreach($test22 as $test24){
                         $array6=["customer_name"=> $test24->customer_name,"delivery_status"=>$test24->delivery_status,"date"=>$test24->date,"customer_id"=>$test24->customer_id,"time"=>$test24->time];
                         array_push($final_result, $array6);
                         break;
                    }
                }
            }
                $paginate_data = $this->paginate($final_result);
               return response()->json(["type"=>"order_page","paginate_data"=>$paginate_data]);
                      }
                      
                 }elseif($page_type == "customer_page"){
                         
                         
                         
                         if(is_int($search_query)){
                                  $allbuyers = User::select('id','name','email','phone_number','destination_address','state','active')->where('id',$search_query)->paginate(10);
                                return response()->json(["type"=>"customer_page","customer_page"=>$allbuyers]);
                      }else{
                            $allbuyers = User::select('id','name','email','phone_number','destination_address','state','active')->where('name','LIKE', "%{$search_query}%")->paginate(10);
                                return response()->json(["type"=>"customer_page","customer_page"=>$allbuyers]);
                      }
                               
                 }elseif($page_type == "seller_page"){
                     if(is_int($search_query)){
                            $seller_list= Admin::select('id','company_name','email','company_phone_number','active')->where('id',$search_query)->paginate(10);
                            return response()->json(["type"=>"seller_page","seller_list"=>$seller_list]);
                            
                     }else{
                             $seller_list= Admin::select('id','company_name','email','company_phone_number','active')->where('company_name','LIKE', "%{$search_query}%")->paginate(10);
                            return response()->json(["type"=>"seller_page","seller_list"=>$seller_list]);
                      }
                 }
    }
    
    
    
//admin global search
     //superadmin global search variable
    public function seller_admin_search_api(Request $request){
                 $page_type=$request->page_type;
                 $search_query = $request->query_data;
                  $token = JWTAuth::parseToken()->getPayload()->toArray();
                  $id=$token['id'];
                 if($page_type == "product_page"){
                          if(is_numeric($search_query)){
                              
                                $products = Products::where('owner_id',$id)->where('id',$search_query)->paginate(10)->toArray();
                $product_array=array();
                foreach($products['data'] as $product){
                        $product_id=$product["id"];
                        $product_image= Sub_product::where('product_id',$product_id)->first();
                        $image_url=$product_image->image_url;
                        $product_order_count=Orders::where('product_id',$product_id)->count();
                        $product_amount_made= Orders::where('product_id',$product_id)->sum('product_price');
                        $date_time_created= $product["created_date"].','.$product["created_time"];
                        $aprove_status= "";
                        if($product["product_aprove_status"] == true){
                           $aprove_status= "Approved";
                        }else{
                            $aprove_status= "Not Approved";
                        }
                        $product_list=[
                             "id"=>$product["id"],
                            "product_name"=>$product["product_name"],
                            "product_price"=>$product["product_price"],
                            "product_image"=>$image_url,
                            "product_stock"=>$product["stock"],
                            "approved_status"=>$aprove_status,
                            "product_amount_sold"=> $product_order_count,
                            "product_amount_made"=> $product_amount_made,
                            "date_time"=>$date_time_created,
                            "product_stock_quantity"=> $product["product_quantity"]
                            ];
                        array_push($product_array, $product_list);
                }
                           return response()->json(["type"=>"product_page","product_array"=>$product_array]);
                          }else{
                        $products = Products::where('owner_id',$id)->where('product_name','LIKE' , "%{$search_query}%")->paginate(10)->toArray();
                $product_array=array();
                foreach($products['data'] as $product){
                        $product_id=$product["id"];
                        $product_image= Sub_product::where('product_id',$product_id)->first();
                        $image_url=$product_image->image_url;
                        $product_order_count=Orders::where('product_id',$product_id)->count();
                        $product_amount_made= Orders::where('product_id',$product_id)->sum('product_price');
                        $date_time_created= $product["created_date"].','.$product["created_time"];
                        $aprove_status= "";
                        if($product["product_aprove_status"] == true){
                           $aprove_status= "Approved";
                        }else{
                            $aprove_status= "Not Approved";
                        }
                        $product_list=[
                             "id"=>$product["id"],
                            "product_name"=>$product["product_name"],
                            "product_price"=>$product["product_price"],
                            "product_image"=>$image_url,
                            "product_stock"=>$product["stock"],
                            "approved_status"=>$aprove_status,
                            "product_amount_sold"=> $product_order_count,
                            "product_amount_made"=> $product_amount_made,
                            "date_time"=>$date_time_created,
                            "product_stock_quantity"=> $product["product_quantity"]
                            ];
                        array_push($product_array, $product_list);
                }
                       return response()->json(["type"=>"product_page","product_array"=>$product_array]);
                   
                          }
                 }elseif($page_type == "order_page"){
                      if(is_int($search_query)){
                           $order_list= Orders::where('owner_id',$id)->where('id',$search_query)->orderBy('id','desc')->get()->groupBy('customer_id');
            
            $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          $filtered_data=[];
            foreach($arrayvalue as $date8){
                foreach($date8 as $test2=>$test3){
                    $test5= $test3->groupBy('time');
                array_push($filtered_data , $test5);
                }
               
            }
            $final_result =[];
             foreach($filtered_data as $value_data){
                foreach($value_data as $test21=>$test22){
                    foreach($test22 as $test24){
                         $array6=["customer_name"=> $test24->customer_name,"delivery_status"=>$test24->delivery_status,"date"=>$test24->date,"customer_id"=>$test24->customer_id,"time"=>$test24->time];
                         array_push($final_result, $array6);
                         break;
                    }
                }
            }
                $paginate_data = $this->paginate($final_result);
               return response()->json(["type"=>"order_page","paginate_data"=>$paginate_data]);
                      } else{
                            $order_list= Orders::where('owner_id',$id)->where('customer_name','LIKE', "%{$search_query}%")->orderBy('id','desc')->get()->groupBy('customer_id');
            
            $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          $filtered_data=[];
            foreach($arrayvalue as $date8){
                foreach($date8 as $test2=>$test3){
                    $test5= $test3->groupBy('time');
                array_push($filtered_data , $test5);
                }
                  
                
            }
            $final_result =[];
             foreach($filtered_data as $value_data){
                foreach($value_data as $test21=>$test22){
                    foreach($test22 as $test24){
                         $array6=["customer_name"=> $test24->customer_name,"delivery_status"=>$test24->delivery_status,"date"=>$test24->date,"customer_id"=>$test24->customer_id,"time"=>$test24->time];
                         array_push($final_result, $array6);
                         break;
                    }
                }
            }
                $paginate_data = $this->paginate($final_result);
               return response()->json(["type"=>"order_page","paginate_data"=>$paginate_data]);
                      }
                      
                 }
    }
    
    public function verify_device_id(Request $request){
            $validator = Validator::make($request->all(), [
                'device_id'=>'required'
            ]);

            if($validator->fails()){
                    return response()->json(["status"=>"failed","message"=>"input field required"], 400);
            }else{
                 $token = JWTAuth::parseToken()->getPayload()->toArray();
                  $id=$token['id'];
                $check_device_id = Deviceid::where('deviceid', $request->device_id)->first();
                if($check_device_id){
                    User::where('id', $id)->update([
                        "device_id"=> $request->device_id,
                        "device_verified"=> true
                        ]);
                        
                    return response()->json([
                        "status"=>"success",
                        "message"=>"verified"
                        ]);
                }else{
                    return response()->json([
                        "status"=>"failed",
                        "message"=>"invalid id"
                        ]); 
                }
            }
    }
    
    //get nearest service agent 
    public function get_service_agent(Request $request){
         $validator = Validator::make($request->all(), [
               
                'category'=>'required'
            ]);

            if($validator->fails()){
                    return response()->json(["status"=>"failed","message"=>"input field required"], 400);
            }else{
                if($request->text){
                          $area1= $request->text;

             $area = str_replace(' ', '%20', $area1);

             $curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://maps.googleapis.com/maps/api/geocode/json?address={'.$area.'}&key=AIzaSyAN4lc1-JLSGrY97rGNQ9RpiQAoq3KuRbg',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'GET',
));

$response = curl_exec($curl);

curl_close($curl);


$res =json_decode($response);
$t = $res->results;

$array="";
if($t){
foreach($t as $m){
      $array = $m->geometry->location;
      break;
}

    $latitude =  $array->lat;
        $longitude =  $array->lng;
        $radius = 7000;
        //          $agent = Service_agent::selectRaw("id, name, phone_number, bio, working_time, lat, log, ratings,
        //              ( 6371000 * acos( cos( radians(?) ) *
        //               cos( radians( lat ) )
        //               * cos( radians( log ) - radians(?)
        //               ) + sin( radians(?) ) *
        //               sin( radians( lat ) ) )
        //              ) AS distance", [$latitude, $longitude, $latitude])
        // ->where('category', $request->category)
        // ->having("distance", "<", $radius)
        // ->orderBy("distance",'asc')
        // ->offset(0)
        // ->paginate(10)
        // ->get();
          $agent = Service_agent::where('category', $request->category)->paginate(10);
    return response()->json($agent);
                }}
                else{
         
        $latitude =  $request->lat;
        $longitude =  $request->log;
        $radius = 7000;
        //       $agent = Service_agent::selectRaw("id, name, phone_number, bio, working_time, lat, log, ratings,
        //              ( 6371000 * acos( cos( radians(?) ) *
        //               cos( radians( lat ) )
        //               * cos( radians( log ) - radians(?)
        //               ) + sin( radians(?) ) *
        //               sin( radians( lat ) ) )
        //              ) AS distance", [$latitude, $longitude, $latitude])
        // ->where('category', $request->category)
        // ->having("distance", "<", $radius)
        // ->orderBy("distance",'asc')
        // ->offset(0)
        // ->limit(20)
        // ->paginate(10);
          $agent = Service_agent::where('category', $request->category)->paginate(10);
    return response()->json($agent);
    
    }}
    }
    //rate agent
    public function rate_agent(Request $request){
         $validator = Validator::make($request->all(), [
                'agent_id'=>'required',
                 'ratings'=>'required',
                 
            ]);

            if($validator->fails()){
                    return response()->json(["status"=>"failed","message"=>"input field required"], 400);
            }else{
                  $token = JWTAuth::parseToken()->getPayload()->toArray();
                  $id=$token['id'];
                  
                  Agent_rating::where('user_id', $id)->where('agent_id', $request->agent_id)->delete();
                Agent_rating::create([
                    "agent_id"=> $request->agent_id,
                    "ratings"=>$request->ratings,
                    "user_id"=> $id,
                    "text"=>$request->text
                    ]);
                    
                $count_agent = Agent_rating::where('agent_id', $request->agent_id)->count();
                $sum_rating = Agent_rating::where('agent_id', $request->agent_id)->sum('ratings');
                
                $final_result = $sum_rating / $count_agent;
                
            
                Service_agent::where('id', $request->agent_id)->update([
                         "ratings"=>$final_result
                    ]);
                
                return response()->json([
                    
                    "status"=>"sucess"
                    ], 200);
            }
    }
    
    //get agent rating
    public function get_agent_rating(Request $request){
            $validator = Validator::make($request->all(), [
                'agent_id'=>'required',
            ]);

            if($validator->fails()){
                    return response()->json(["status"=>"failed","message"=>"input field required"], 400);
            }else{
                 $token = JWTAuth::parseToken()->getPayload()->toArray();
                  $id=$token['id'];
                 $ratings=Agent_rating::where('agent_id', $request->agent_id)->get();
                 
              
                 $final_array = [];
                 foreach($ratings as $data){
                     $get_user = User::where('id', $data->user_id)->first();
                     
                    
                     $array21 = [
                    "agent_id"=>  $data->agent_id,
                    "ratings"=> $data->ratings,
                    "user_name"=> $get_user->name,
                    "text"=> $data->text
                         ];
                         
                         array_push($final_array, $array21);
                 }
                 return response()->json($final_array);
            }
    }
    
     public function  request_a_service_agent(Request $request){
             
              $validator = Validator::make($request->all(), [
                
                 'agent_id'=>'required'
            ]);

            if($validator->fails()){
                    return response()->json(["status"=>"failed","message"=>"input field required"], 400);
            }else{
                 $token = JWTAuth::parseToken()->getPayload()->toArray();
                  $id=$token['id'];
                   $carbondate=Carbon::now();
                $date = $carbondate->toDateString();
                $time= $carbondate->now('UTC')->setTimezone('WAT')->format('g:i:s a');
             if($request->text){
                  
                 
                       $area1= $request->text;

             $area = str_replace(' ', '%20', $area1);

             $curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://maps.googleapis.com/maps/api/geocode/json?address={'.$area.'}&key=AIzaSyAN4lc1-JLSGrY97rGNQ9RpiQAoq3KuRbg',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'GET',
));

$response = curl_exec($curl);

curl_close($curl);


$res =json_decode($response);

$t = $res->results;

$array="";
if(!empty($t)){
foreach($t as $m){
      $array = $m->geometry->location;
      break;
}       
           $check= Book_agent::where('mechanic_id', $request->agent_id)->where('user_id', $id)->first();
           if($check){
                 Book_agent::where('mechanic_id', $request->agent_id)->where('user_id', $id)->update([
                     "lat"=>$array->lat,
                     "log"=>$array->lng,
                     "user_id"=>$id,
                     "mechanic_id"=>$request->agent_id,
                     "date"=>$date,
                     "time"=>$time
                 ]) ;
              return response()->json([
                     "status"=>"success",
                     "message"=>"request sent"
                     ]);
            }else{
                 Book_agent::create([
                     "lat"=>$array->lat,
                     "log"=>$array->lng,
                     "user_id"=>$id,
                     "mechanic_id"=>$request->agent_id,
                     "date"=>$date,
                     "time"=>$time
                 ]) ;
                 
                 return response()->json([
                     "status"=>"success",
                     "message"=>"request sent"
                     ]);
               
            }}else{
                 return response()->json([
                     "status"=>"failed",
                     "message"=>"invalid address"
                     ]);
            } }else{
                  $check= Book_agent::where('mechanic_id', $request->agent_id)->where('user_id', $id)->first();
                  if($check){
                      
                           
                 Book_agent::where('mechanic_id', $request->agent_id)->where('user_id', $id)->update([
                    "lat"=>$request->lat,
                     "log"=>$request->log,
                     "user_id"=>$id,
                     "mechanic_id"=>$request->agent_id,
                     "date"=>$date,
                     "time"=>$time
                 ]) ;
              return response()->json([
                     "status"=>"success",
                     "message"=>"request sent"
                     ]);
                  }else{
                        Book_agent::create([
                     "lat"=>$request->lat,
                     "log"=>$request->log,
                     "user_id"=>$id,
                     "mechanic_id"=>$request->agent_id,
                       "date"=>$date,
                     "time"=>$time
                 ]) ;
                 
                  
                 return response()->json([
                     "status"=>"success",
                     "message"=>"request sent"
                     ]);
                  }
                
             }
       
    
   }
    
    
    
     }
}
