<?php

namespace App\Http\Controllers;
use App\Models\Breathalyzer_result;
use App\Models\Breathalyzer_driver;

use App\Models\Breathalyzer_assigned_to_drivers;

use Illuminate\Http\Request;

use Illuminate\Support\Facades\Validator;


class Breathalyzer extends Controller
{
    public function post_breathalyzer_results(Request $request){
               
                $validator = Validator::make($request->all(), [
                'alcohol_test_results' => 'required',
                'test_id' => 'required',
                'date'=>'required',
                'time' => 'required',
                'device_id'=>'required',
                
            ]);

            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                Breathalyzer_result::create([
                    "alcohol_test_results"=> $request->alcohol_test_results,
                    "test_id"=>$request->test_id,
                    "date"=>$request->date,
                    "time"=> $request->time,
                    "device_id"=>$request->device_id
                    
                    ]);
                    
                return response()->json([
                    "status"=>"success",
                    "message"=>"result saved"
                    ]);
            }
               
               
               
               
    }
    //get breathalyzer result
    
    public function get_assigned_breathalyzer_data(Request $request){
                   $get_device_id = $request->query('device_id');
                   
                   $get_driver_id= Breathalyzer_assigned_to_drivers::where('breathalyzer_id', $get_device_id)->first();
                   
                  $driver_details= Breathalyzer_driver::where('id', $get_driver_id->driver_id)->first();
                   
                   return response()->json([
                         "driver_name"=> $driver_details->drivers_name,
                         "test_id"=> $get_driver_id->test_id,
                         "device_id"=>$get_driver_id->breathalyzer_id
                       ]);
                   
    }
    
    
    
    
    
    
    
}