<?php

namespace App\Http\Controllers;
use App\Models\User;
use App\Models\Products;

use App\Models\Customer_transaction;

use App\Models\Admin;

use App\Models\Orders;
use App\Models\Notification;
use App\Models\Sub_product;
use Illuminate\Http\Request;

use Illuminate\Support\Facades\Validator;

use Tymon\JWTAuth\Facades\JWTAuth;

use Auth;
use Tymon\JWTAuth\Exceptions\JWTException;
use Carbon\Carbon;
class Customers extends Controller
{
    
    public function get_all_customers(){
                 $allbuyers = User::select('id','name','email','phone_number','destination_address','state','active')->paginate(10);
                 return response()->json($allbuyers);
    }
    //customer count
    public function customer_count(){
            $total_number_of_customer = User::count();
            $total_active_customer = User::where('active',true)->count();
            $total_suspended_customer = User::where('active',false)->count();
            
            return response()->json(["total_number_of_customer"=>$total_number_of_customer ,"total_active_customer"=>$total_active_customer,"total_suspended_customer"=>$total_suspended_customer]);
    }
    public function suspend_customer_account(User $user){
            User::where('id',$user->id)->update([
                       "active"=>false
                ]);
                
                return response()->json(['status'=>"success"]);
    }
    //get customer details
    public function get_customer_details(User $user){
        $total_number_of_ordersmade = Customer_transaction::where('customer_id',$user->id)->count();
        $customer=[
            "name"=>$user->name,
            "email"=>$user->email,
            "phone_number"=>$user->phone_number,
            "destination_address"=>$user->destination_address,
            "state"=>$user->state,
            "total_number_of_ordersmade"=> $total_number_of_ordersmade
            ];
            
            return response()->json($customer);
    }
    //get all orders of a customer 
    public function get_customer_ordered_product(User $user){
                 $orders= Customer_transaction::where('customer_id',$user->id)->get();
                 $final_result= array();
                 foreach($orders as $order){
                     $items_bought = unserialize($order->items_bought);
                     $array= [
                         "date"=>$order->date,
                         "time"=>$order->time,
                         "order"=>$items_bought
                         
                         ];
                         
                        array_push($final_result, $array);
                 }
                return response()->json($final_result);
    }
}