<?php

namespace App\Http\Controllers;

use App\Models\Agent;
use App\Models\Device;
use App\Models\heart_beat;

use App\Models\Accident_detection;
use App\Events\NewRequestEvent;
use Illuminate\Http\Request;
use Carbon\Carbon;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Queue;
use Illuminate\Support\Facades\Event; 
class Devicecontroller extends Controller
{
     public function register_device(Request $request){
          $validator = Validator::make($request->all(), [
                'device_id' => 'required',
                'device_number' => 'required',
                'device_ime'=>'required',
                'owner_name' => 'required',
                'owner_phone_number'=>'required',
                'owner_email'=>'required',
                'owner_address'=>'required',
                'vehicle_name'=>'required',
                'vehicle_plate_number'=>'required',
                'vehicle_chasses_number'=>'required',
                'vehicle_model_year'=>'required'
                
            ]);

            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }
            
            $checkdevice = Device::where("device_id", $request->device_id)->first();
            if($checkdevice){
              return response()->json(["message"=>"Duplicate"], 400);
            }
            
    Device::create([
        "device_id" => $request->device_id,
        "device_number" => $request->device_number,
        "device_ime" => $request->device_ime,
        "owner_name" => $request->owner_name,
        "owner_phone_number"=> $request->owner_phone_number,
        "owner_email"=> $request->owner_email,
        "owner_address" => $request->owner_address,
        "vehicle_name" => $request->vehicle_name,
        "vehicle_plate_number"=> $request->vehicle_plate_number ,
        "vehicle_chasses_number" => $request->vehicle_chasses_number,
        "vehicle_model_year" => $request->vehicle_chasses_number
                     ]);
                 
                 
                 
                 
                return response()->json(["message"=>"created"], 200);
    }
    
    
    //get all devices 
    public function get_all_devices(Request $request){
        $get_devices = Device::paginate(10);
        $array = [];
           $onlinedevice = Device::where("status", "online")->count();
        $offlinedevice = Device::where("status", "offline")->count();
        $sos = Accident_detection::where("agent_id", ">", 0)->where("nature_of_request", "SOS")->count();
        
        $accident_detected = Accident_detection::where("agent_id", ">", 0)->where("nature_of_request", "ACCIDENT DETECTED")->count();
        
        $manualscan = Accident_detection::where("agent_id", ">", 0)->where("nature_of_request", "Manual Scan")->count();
        
        $pending_case = Accident_detection::where("request_accepted", ">", 0)->where("responder_id", 0)->count();
        
        $attended_case = Accident_detection::where("agent_id", ">", 0)->where("responder_id", ">", 0)->where("closed_status", 0)->count();
        
        $totalvehicle = Device::count();
        
        $counts = [
            "onlinedevice"=>$onlinedevice,
            "offlinedevice"=>$offlinedevice,
            "sos"=>$sos,
            "accident_detected"=> $accident_detected,
            "manualscan"=>$manualscan,
            "pending_case"=>$pending_case,
            "attended_case"=>$attended_case,
            "totalvehicle"=>$totalvehicle
            ];
                   
                  
                  
        
        
        return response()->json(["counts"=>$counts,"devices"=>$get_devices], 200);
    }
    
    //get device details 
    public function get_device_details(Request $request){
                    $device_id = $request->query("device_id");
                      
                    $accident_history = Accident_detection::where("agent_id", ">", 0)->where("deviceid",$device_id)->where("closed_status", ">", 0)->get();
                  
                  $accident_detected = Accident_detection::where("agent_id", ">", 0)->where("deviceid",$device_id)->where("closed_status", 0)->first();
                  
                  $getdevicedetails = Device::where("device_id", $device_id)->first();
                  
                   return response()->json(["devicedetails"=>$getdevicedetails,"accident_detected"=>$accident_detected,"accident_history"=> $accident_history], 200);
    }
    
    
    
    
    
    
    //update device details 
    public function update_device_details(Request $request){
         $validator = Validator::make($request->all(), [
                'id'=>'required',
                'device_number' => 'required',
                'device_ime'=>'required',
                'owner_name' => 'required',
                'owner_phone_number'=>'required',
                'owner_email'=>'required',
                'owner_address'=>'required',
                'vehicle_name'=>'required',
                'vehicle_plate_number'=>'required',
                'vehicle_chasses_number'=>'required',
                'vehicle_model_year'=>'required'
                
            ]);

            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }
            
          
           
        Device::where("id",$request->id)->update([
        "device_number" => $request->device_number,
        "device_ime" => $request->device_ime,
        "owner_name" => $request->owner_name,
        "owner_phone_number"=> $request->owner_phone_number,
        "owner_email"=> $request->owner_email,
        "owner_address" => $request->owner_address,
        "vehicle_name" => $request->vehicle_name,
        "vehicle_plate_number"=> $request->vehicle_plate_number ,
        "vehicle_chasses_number" => $request->vehicle_chasses_number,
        "vehicle_model_year" => $request->vehicle_chasses_number
                     ]);
                     
        
         return response()->json(["message"=>"updated"], 200);
    }
    
    //post accident detected
    public function accident_detection(Request $request){
          $validator = Validator::make($request->all(), [
                'deviceid' => 'required',
                'nature_of_request' => 'required',
                'accident_type'=>'required',
                'date'=>'required',
                'lat'=>'required',
                'log'=>'required',
                'time'=>'required'
                
            ]);
            
            
              if($validator->fails()){
                    return response()->json($validator->errors(), 400);
        
              }
            //check Accident_detection
            
            $check_accident_detection = Accident_detection::where("deviceid", $request->deviceid)->where("closed_status", 0)->count();
            
            if($check_accident_detection > 0){
                
            
            
            
            $checkdevice = Device::where("device_id", $request->deviceid)->first();
            
            if($checkdevice){
                
                $check_device_accident_case = Accident_detection::where("closed_status", 0)->first();
                
                if(!$check_device_accident_case){
                     $getagent;
           $getagent = Agent::where("account_disabled", 1)->where("status","online")->inRandomOrder()->first();
           
           if(!$getagent){
                 $getagent = Agent::where("account_disabled", 1)->where("status","busy")->inRandomOrder()->first();
           }
           
            $carbondate=Carbon::now();
    $accident = Accident_detection::create([
        "deviceid" => $request->deviceid,
        "nature_of_request" => $request->nature_of_request,
        "accident_type" => $request->accident_type,
        "date"=> $request->date,
        "lat" => $request->lat,
        "log" => $request->log,
        "time"=> $request->time,
        "assigned_at"=>$carbondate,
        "agent_id"=> $getagent->id,
        "closed_status"=>0,
        "request_accepted"=>0
                     ]);
        
    return response()->json(["message"=>"created"], 200);
    
    
                }
           


         
         
            }else{
                 return response()->json(["message"=>"No device found"], 400);
            }
            
            }
    }
    
    //create heart beat
    public function heart_beat(Request $request){
                 $validator = Validator::make($request->all(), [
                'deviceid' => 'required',
                'latitude' => 'required',
                'longitude'=>'required',
                'activity'=>'required'
                
            ]);
            
            
              if($validator->fails()){
                    return response()->json($validator->errors(), 400);
        
              }
              
                $checkdevice = Device::where("device_id", $request->deviceid)->first();
            
            if($checkdevice){
              $carbondate=Carbon::now();
             $devices = Device::get();
              
              
                heart_beat::create([
                  "deviceid"=> $request->deviceid,
                  "latitude"=> $request->latitude,
                  "longitude"=> $request->longitude,
                  "date"=>$carbondate,
                  "activity"=> $request->activity
                  
                  ]);
                  
                 Device::where("device_id",$request->deviceid)->update([
                          "status" => "online"
                          ]);
                          
                          
              foreach($devices as $data){
                  $checkstatus =heart_beat::where('deviceid', $data->device_id)->orderBy('date', 'desc')->first();
                  
                  if($checkstatus){
                       if($carbondate->diffInSeconds($checkstatus->date) >= 600){
                      Device::where("device_id",$data->device_id)->update([
                          "status" => "offline"
                          ]);
                  }
                  }
                 
              }
              
              
              
            
                  
            return response()->json(["message"=>"created"], 200);      
                
                
    }else{
        return response()->json(["message"=>"No device found"], 400);
    }
    
    }
    
    
 //close accident case
 public function close_accident_case(Request $request){
     
            $validator = Validator::make($request->all(), [
                'accident_id' => 'required'
                
            ]);
            
            
              if($validator->fails()){
                    return response()->json($validator->errors(), 400);
        
              }
                $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                   $type=$token['role'];
            
            $getaccident = Accident_detection::where("id", $request->accident_id)->first();
            if($getaccident){
                 if($getaccident->request_accepted ==1 && $getaccident->agent_id == $id){
                Accident_detection::where("id", $request->accident_id)->update([
                    "closed_status"=> 1
                    ]);
                    
            return response()->json(["message"=>"case closed"], 200);  
            }
            }else{
                 return response()->json(["message"=>"N"], 400);
            }
           
 }
    
}