<?php

namespace App\Http\Controllers;
use App\Models\User;
use App\Models\Products;

use App\Models\Superadmin;
use App\Models\Product_review;
use App\Models\Customer_transaction;
use App\Models\Book_agent;

use App\Models\Service_agent;
use App\Models\Admin;
use App\Jobs\Sendorderalert;
use App\Jobs\Orderreceipt;

use App\Models\Orders;
use App\Models\Notification;
use App\Models\Sub_product;
use Illuminate\Http\Request;

use Illuminate\Pagination\Paginator;
use Illuminate\Support\Collection;
use Illuminate\Pagination\LengthAwarePaginator;

use Illuminate\Support\Facades\Validator;

use Tymon\JWTAuth\Facades\JWTAuth;

use Auth;
use Tymon\JWTAuth\Exceptions\JWTException;
use Carbon\Carbon;
class Orderscontroller extends Controller
{
    
    
   
    //get order list for admin/seller
       public function get_adminorderedproduct(){
                $token = JWTAuth::parseToken()->getPayload()->toArray();
                $id=$token['id'];
                
              $order_list= Orders::where("owner_id",$id)->get()->groupBy('customer_id');
            
             $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          $filtered_data=[];
            foreach($arrayvalue as $date8){
                foreach($date8 as $test2=>$test3){
                    $test5= $test3->groupBy('time');
                array_push($filtered_data , $test5);
                }
                  
                
            }
            
            $final_result =[];
             foreach($filtered_data as $value_data){
                foreach($value_data as $test21=>$test22){
                    foreach($test22 as $test24){
                         $array6=["customer_name"=> $test24->customer_name,"delivery_status"=>$test24->delivery_status,"date"=>$test24->date,"customer_id"=>$test24->customer_id,"time"=>$test24->time];
                         array_push($final_result, $array6);
                         break;
                    }
                }
            }
               $paginated_data =$this->paginate($final_result);
               return response()->json($paginated_data);
    }
    //admin/seller oder filter by date range
    public function admin_orders_date_range_filter(Request $request){
             $token = JWTAuth::parseToken()->getPayload()->toArray();
                $id=$token['id'];
                           $from_date= $request->from;
                           $end_date = $request->to;
               $order_list= Orders::where('owner_id',$id)->whereBetween('date', [$from_date, $end_date])->orderBy('id','desc')->get()->groupBy('customer_id');
            if($order_list){
       $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          $filtered_data=[];
            foreach($arrayvalue as $date8){
                foreach($date8 as $test2=>$test3){
                    $test5= $test3->groupBy('time');
                array_push($filtered_data , $test5);
                }
                  
                
            }
            
            $final_result =[];
             foreach($filtered_data as $value_data){
                foreach($value_data as $test21=>$test22){
                    foreach($test22 as $test24){
                         $array6=["customer_name"=> $test24->customer_name,"delivery_status"=>$test24->delivery_status,"date"=>$test24->date,"customer_id"=>$test24->customer_id,"time"=>$test24->time];
                         array_push($final_result, $array6);
                         break;
                    }
                }
            }
            
               return response()->json($customer_name);
            }else{
                return response()->json([
                    "status"=>"failed",
                    "message"=>"No records found"
                    ]);
            }
          
            }
    //order details
    public function admin_order_details(Request $request){
                 
                $super_admin =  Superadmin::first();
                $commission =   $super_admin->super_admin_commission;
                
                $date= $request->date;
                $id = $request->id;
                $time= $request->time;
                $user = Orders::where('date',$date)->where('customer_id',$id)->first();
               $orders = Orders::where('customer_id',$id)->where('date',$date)->where('time',$time)->get();
               if($orders){
                   
              
               $final_result=[];
               foreach($orders as $value){
                         $product_price=(int)$value->amount_ordered * (int)$value->product_price;
                         $superadmin_amount_made_from_commission = (int)$value->product_price *  $commission;
                         $amount_to_be_paid =(int)$product_price - $superadmin_amount_made_from_commission;
                         $data = [
                             "customer_name"=>$user->customer_name,
                             "product_name"=>$value->product_name,
                             "image_url"=>$value->image_url,
                             "product_price"=>$value->product_price,
                             "amount_ordered"=>$value->amount_ordered,
                             "payment_status"=>$value->status,
                             "product_size"=>$value->product_size,
                             "superadmin_commission_on_product"=>$superadmin_amount_made_from_commission,
                             "amount_to_be_paid"=>$amount_to_be_paid
                             ];
                             
                             array_push($final_result, $data);
               }
               return response()->json($final_result);
    }else{
        return response()->json([
            "status"=>"failed",
            "message"=>"No record found"
            ]);
    }
        
    }
    
    //super admin get wallet data of seller
     public function test_wallet(){
          $order_list= Orders::where('status',"pending")->get()->groupBy('owner_id');
         
          return response()->json($order_list);
     }
    public function superadmin_get_wallet(){
        //   collect($pagination_data['data'])->groupBy('owner_id');
            // $pagination_data= Orders::where('status',"pending")->paginate(10)->toArray();
            $order_list =Orders::where('status',"pending")->get()->groupBy('owner_id');
            $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          $seller_name=[];
            foreach($arrayvalue as $test1){
                foreach($test1 as $test2=>$test3){
                    foreach($test3 as $test4){
                        
                        $owner_id= $test4['owner_id'];
                         $seller= Admin::where('id',$owner_id)->first();
                         
                         $array6=["owner_id"=> $owner_id,"company_name"=> $seller->company_name,"payment_status"=>$test4['status'],"date"=>$test4['date']];
                         array_push($seller_name, $array6);
                         break;
                    }
                }
            }
            $final = $this->paginate($seller_name);
               return response()->json($final);
    }
    // ["current_page"=>$pagination_data['current_page'],"data"=>$seller_name,"first_page_url"=>$pagination_data['first_page_url'],"last_page_url"=>$pagination_data['last_page_url'],"next_page_url"=>$pagination_data['next_page_url'],"prev_page_url"=>$pagination_data['prev_page_url'],"per_page"=>$pagination_data['per_page'],"total"=>$pagination_data['total']]
           
    
       public function paginate($items, $perPage = 5, $page = null, $options = [])
    {
        $page = $page ?: (Paginator::resolveCurrentPage() ?: 1);
        $items = $items instanceof Collection ? $items : Collection::make($items);
        return new LengthAwarePaginator($items->forPage($page, $perPage), $items->count(), $perPage, $page, $options);
    }
    
    
    //super admin get wallet history
     public function superadmin_get_wallet_history(){
           
            $order_list= Orders::where('status',"paid")->get()->groupBy('owner_id');
            
            $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          $seller_name=[];
            foreach($arrayvalue as $test1){
                foreach($test1 as $test2=>$test3){
                    foreach($test3 as $test4){
                        $owner_id= $test4->owner_id;
                         $seller= Admin::where('id',$owner_id)->first();
                         
                         $array6=["owner_id"=> $owner_id,"company_name"=> $seller->company_name,"payment_status"=>$test4->status,"date"=>$test4->date,"paid_date"=>$test4->paid_date];
                         array_push($seller_name, $array6);
                         break;
                    }
                }
            }
            
            $final = $this->paginate($seller_name);
               return response()->json($final);
    }
    //super admin pay sellers 
    public function pay_sellers(Request $request){
                    $date =  $request->query('date');
                    $owner_id =    $request->query('owner_id');
                    $admin_details= Admin::where('id', $owner_id)->first();
                    $total_amount_to_pay = $request->query('amount_to_pay');
                    $carbondate=Carbon::now();
                    $date = $carbondate->toDateString();
                    $time= $carbondate->now('UTC')->setTimezone('WAT')->format('g:i:s a');
                     if($total_amount_to_pay > 0){
                    $orders=Orders::where("owner_id",$owner_id)->where("date",$date)->get();
                    foreach($orders as $value){
                        $id = $value->id;
                        Orders::where("id",$id)->update([
                                  "status"=>"paid",
                                  "paid_date"=>$date. ' '. $time
                            ]);
                    }
                   
                        $amount_in_wallet=(int)$admin_details->wallet - (int)$total_amount_to_pay;
                        Admin::where('id', $owner_id)->update([
                            "wallet"=>$amount_in_wallet
                            ]);
                            
                            return response()->json([
                                 "status"=>"success"
                                ]);
                    }else{
                        return response()->json([
                                 "status"=>"failed"
                                ]);
                    }
                    
    }
    //get wallet details
    public function get_wallet_details(Request $request){
                  $id = $request->owner_id;
                  $date= $request->date;
                  
                  $get_order_details = Orders::where("owner_id",$id)->where("date",$date)->get();
                  $admin_details= Admin::where('id',$id)->first();
                  
               
                  $total_amount_tobe_paid =0;
                  $superadmin = Superadmin::first();
                  $commission = $superadmin->super_admin_commission;
                  
                  
                  $wallet_array_list=[];
                  foreach($get_order_details  as $value){
                           $product_price = $value->product_price;
                           $product_quantity= $value->amount_ordered;
                           $total_amount = (int)$product_price * (int)$product_quantity;
                           $total_amount_made_fromcommission = $total_amount * $commission;
                           $final_amount = $total_amount - $total_amount_made_fromcommission;
                           $total_amount_tobe_paid +=  $final_amount;
                           
                           $array=[
                               "id"=>$value->id,
                               "product_name"=>$value->product_name,
                               "product_image"=>$value->image_url,
                               "payment_status"=>$value->status,
                               "product_price"=> $value->product_price,
                               "product_size"=>$value->product_size,
                               "commission_on_product"=>$commission,
                               "product_quantity"=>$value->amount_ordered,
                               "total_amount_product_made"=>$total_amount,
                               "total_amount_made_fromcommission"=>$total_amount_made_fromcommission,
                               "amount_to_pay_seller"=>$final_amount
                               ];
                           
                           array_push($wallet_array_list, $array);
                           
                  }
                    $admin=[
                        "id"=>$admin_details->id,
            "company_name"=>$admin_details->company_name,
            "email"=>$admin_details->email,
            "passport_photo"=>$admin_details->passport_photo,
            "state"=>$admin_details->state,
            "address"=>$admin_details->address,
            "company_phone_number"=>$admin_details->company_phone_number,
            "total_amount_tobe_paid"=> $total_amount_tobe_paid,
            "account_details"=>$admin_details->account_details,
                      ];
                      
                  $final_result=[
                      "seller_details"=>$admin,
                      "wallet_list"=>$wallet_array_list
                      
                      ];
                  return response()->json($final_result);
    }
    
    
    
    
    
   
    //super admin wallet ends
    //super admin orders
            
            public function orders_on_opticals(){
                           
               $order_list= Orders::orderBy('id','desc')->get()->groupBy('customer_id');
            
            $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          $filtered_data=[];
            foreach($arrayvalue as $date8){
                foreach($date8 as $test2=>$test3){
                    $test5= $test3->groupBy('time');
                array_push($filtered_data , $test5);
                }
                  
                
            }
            
            $final_result =[];
             foreach($filtered_data as $value_data){
                foreach($value_data as $test21=>$test22){
                    foreach($test22 as $test24){
                         $array6=["customer_name"=> $test24->customer_name,"delivery_status"=>$test24->delivery_status,"date"=>$test24->date,"customer_id"=>$test24->customer_id,"time"=>$test24->time];
                         array_push($final_result, $array6);
                         break;
                    }
                }
            }
            
            
                $paginate_data = $this->paginate($final_result);
               return response()->json($paginate_data);
            }
            
            //filter orders by date range
              
            public function orders_date_range_filter(Request $request){
                           $from_date= $request->from;
                           $end_date = $request->to;
                           
               $order_list= Orders::whereBetween('date', [$from_date, $end_date])->orderBy('id','desc')->get()->groupBy('customer_id');
            if($order_list){
       $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          $filtered_data=[];
            foreach($arrayvalue as $date8){
                foreach($date8 as $test2=>$test3){
                    $test5= $test3->groupBy('time');
                array_push($filtered_data , $test5);
                }
                  
                
            }
            
            $final_result =[];
             foreach($filtered_data as $value_data){
                foreach($value_data as $test21=>$test22){
                    foreach($test22 as $test24){
                         $array6=["customer_name"=> $test24->customer_name,"delivery_status"=>$test24->delivery_status,"date"=>$test24->date,"customer_id"=>$test24->customer_id,"time"=>$test24->time];
                         array_push($final_result, $array6);
                         break;
                    }
                }
            }
            
               $paginate_data = $this->paginate($final_result);
               return response()->json($paginate_data);
            }else{
                return response()->json([
                    "status"=>"failed",
                    "message"=>"No records found"
                    ]);
            }
          
            }
            //filter orders by delivery status
                        public function orders_delivery_status_filter(Request $request){
                           $delivery_status= $request->delivery_status;
                           
               $order_list= Orders::where('delivery_status', $delivery_status)->orderBy('id','desc')->get()->groupBy('customer_name');
            if($order_list){
           $arrayvalue = [];
            foreach($order_list as $name=>$value){
                $test2= $value->groupBy('date');
                array_push($arrayvalue , $test2);
                
          }
          
          $filtered_data=[];
            foreach($arrayvalue as $date8){
                foreach($date8 as $test2=>$test3){
                    $test5= $test3->groupBy('time');
                array_push($filtered_data , $test5);
                }
                  
                
            }
            
            $final_result =[];
             foreach($filtered_data as $value_data){
                foreach($value_data as $test21=>$test22){
                    foreach($test22 as $test24){
                         $array6=["customer_name"=> $test24->customer_name,"delivery_status"=>$test24->delivery_status,"date"=>$test24->date,"customer_id"=>$test24->customer_id,"time"=>$test24->time];
                         array_push($final_result, $array6);
                         break;
                    }
                }
            }
            
               $paginate_data = $this->paginate($final_result);
               return response()->json($paginate_data);
            }else{
                return response()->json([
                    "status"=>"failed",
                    "message"=>"No records found"
                    ]);
            }
          
            }
            //update order delivery status
                    public function update_delivery_status(Request $request){
                           $id = $request->customer_id;
                           $date = $request->date;
                           $time = $request->time;
                           $status= $request->status;
                           $user = User::where('id',$id)->first();
                           
                           
                          $orders =  Orders::where('customer_id', $id)->where('time',$time)->where('date',$date)->get();
                           
                           foreach($orders as $order){
                                     $order_id = $order->id;
                                     Orders::where('id', $order_id)->update([
                                         "delivery_status"=>$status
                                         ]);
                           }
                           $title="Delivery Status";
                           $customer_info=[
                               "email"=>$user->email,
                               "name"=>$user->name
                               ];
                               $transaction_details=[
                                   "type"=>"delivery_status",
                                   "delivery_status"=>$status
                                   ];
                           dispatch(new Sendorderalert($title,$customer_info,$transaction_details));
                           return response()->json([
                               "status"=>"success"
                               ]);
                    }
            
            
            //details on orders
            public function orders_details(Request $request){
                        $id = $request->query('customer_id');
                        $date = $request->query('date');
                         $time = $request->query('time');
                        $superadmin = Superadmin::first();
                        $superadmin_commission=$superadmin->super_admin_commission;
                        $get_addresses = Orders::where('customer_id',$id)->where('date',$date)->where('time',$time)->first();
                        
                        $allorders = Orders::select('product_name','product_price','image_url','amount_ordered','date','time')->where('customer_id',$id)->where('date',$date)->where('time',$time)->get();
                        $customer_details = User::where('id',$id)->first();
                        $final_array=[];
                        $customer_array = [
                            "name"=>$customer_details->name,
                            "email"=>$customer_details->email,
                            "phone_number"=>$customer_details->phone_number,
                            "shipping_phone_number"=>$get_addresses->shipping_phone_number,
                            "shipping_name"=>$get_addresses->shipping_name,
                            "destination_address"=> $get_addresses->destination_address,
                            "destination_state"=>$get_addresses->state,
                           "delivery_status"=>$get_addresses->delivery_status
                            ];
                        foreach($allorders as $value){
                                 $product_price= (int)$value->product_price * (int)$value->amount_ordered;
                                 $total_amount_made = (int)$superadmin_commission * $product_price;
                                 
                                 $array = [
                                     "total_amount_made"=>$total_amount_made,
                                     "product_name"=>$value->product_name,
                                     "product_price"=>$value->product_price,
                                     "product_size"=>$value->product_size,
                                     "delivery_status"=>$value->delivery_status,
                                     "amount_ordered"=> $value->amount_ordered,
                                     "image_url"=>$value->image_url,
                                     "date"=>$value->date,
                                     "time"=>$value->time
                                     
                                     ];
                            array_push($final_array,$array);
                        }
                        return response()->json([
                            "customer_detail"=> $customer_array,
                            "products_ordered"=> $final_array
                            ]);
            }
            //end of order details
    //super admin end orders
    
    //seller/admin wallet 
    public function get_admin_wallet(){
                   $token = JWTAuth::parseToken()->getPayload()->toArray();
                $id=$token['id'];
                $superadmin = Superadmin::first();
                $commission = $superadmin->super_admin_commission;
               $order_list= Orders::where("owner_id",$id)->paginate(10)->toArray();
               
               $array1 = array();
               foreach($order_list['data'] as $value){
                        $product_price = (int)$value['product_price'] * (int)$value['amount_ordered'];
                        $amount_made_from_commission = (int)$commission * $product_price;
                        $amount_tobe_paid = $product_price - $amount_made_from_commission;
                        $array2 = [
                            "id"=> $value['id'],
                            "product_name"=> $value['product_name'],
                            "product_price"=> $value['product_price'],
                            "image_url"=> $value['image_url'],
                            "amount_ordered"=> $value['amount_ordered'],
                            "customer_name"=>$value['customer_name'],
                            "payment_status"=>$value['status'],
                            "amount_tobe_paid"=>$amount_tobe_paid,
                            "date"=>$value['date'],
                            "time"=>$value['time']
                            ];
                        
                      array_push($array1, $array2);
      
               }
               
               
               return response()->json(["current_page"=>$order_list['current_page'],"data"=>$array1,"first_page_url"=>$order_list['first_page_url'],"last_page_url"=>$order_list['last_page_url'],"next_page_url"=>$order_list['next_page_url'],"prev_page_url"=>$order_list['prev_page_url'],"per_page"=>$order_list['per_page'],"total"=>$order_list['total']]);
    }
    
    
    //end seller/admin wallet
    
   
    
    
      //pay with paysatck
    public function initialize_payments(Request $request){
        
        $email= $request->email;
        $amount=$request->amount;
        
        
        $service_charge=(int)$amount * 0.015 + 100;
        
        if($service_charge > 2500){
            $service_charge= 2500;
        }
        $paystack_amount= (int)$amount + $service_charge;
        $final_amount_to_pay=  $paystack_amount * 100;
        $link=$request->link;
        $url = "https://api.paystack.co/transaction/initialize";
        $fields = [
          'email' => $email,
          'amount' => $final_amount_to_pay,
          'callback_url'=>$link,
        ];
        $fields_string = http_build_query($fields);
        //open connection
        $ch = curl_init();
        
        //set the url, number of POST vars, POST data
        curl_setopt($ch,CURLOPT_URL, $url);
        curl_setopt($ch,CURLOPT_POST, true);
        curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
          "Authorization: Bearer sk_test_78d3222355597d8e13ada75b3f02230f6849d4d8",
          "Cache-Control: no-cache",
        ));
          //test key
         //sk_test_78d3222355597d8e13ada75b3f02230f6849d4d8
        //live paystack key
        // sk_live_75cd2aea916edd58b62c7dad9ec24f1be553f393
        //So that curl_exec returns the contents of the cURL; rather than echoing it
        curl_setopt($ch,CURLOPT_RETURNTRANSFER, true); 
        
        //execute post
        $result = curl_exec($ch);
        return $result;
    }
//send otp

public function send_otp($name, $number){
      $senderid = 'watchout';
               $to = $number;
               $token = 'BTu64EuGvR6BPPDPiryFxjf4lCilyVGMLAd7mnwLoj1Ya0a6xTxsHg1M4TY1lIrtKSYWyZsQOYunShYvyOmGn0Pjjnp6PbrtJTD1';
           $baseurl = 'https://smartsmssolutions.com/api/json.php?';
           
           $sms_array = array 
             (
             'sender' => $senderid,
             'to' => $to,
             'message' =>"Hello ($name) you have an order please login to your dashboard",
             'type' => '0',
             'routing' => 3,
             'token' => $token
           );
           
           $params = http_build_query($sms_array);
           $ch = curl_init(); 
           
           curl_setopt($ch, CURLOPT_URL,$baseurl);
           curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
           curl_setopt($ch, CURLOPT_POST, 1);
           curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
           
           $response = curl_exec($ch);
           
           curl_close($ch);
               
           $res=json_decode($response);
           
           return $res;
}
    //public function check calculation
    public function verify_checkout_products(Request $request){
          $validator = Validator::make($request->all(), [
                 'products' => 'required',
                 'total_amount' => 'required',
               
            ]);
             
         if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                $carbondate=Carbon::now();
                $date = $carbondate->toDateString();
                $time= $carbondate->now('UTC')->setTimezone('WAT')->format('g:i:s a');
                $token = JWTAuth::parseToken()->getPayload()->toArray();
                $id=$token['id'];
                $customer=User::where('id',$id)->first();
                  $decoded_product= json_decode($request->products, true);
                  $serilize_product= serialize($decoded_product);
                  $message = "";
                   $total_amount_from_app=0;
                   $total_amount_from_backend=0;
                foreach($decoded_product as $value){
                    
                    
                    $get_product= Products::where('id', $value['product_id'])->first();
                    if($value['product_price'] != $get_product->product_price){
                        $message = $value['product_name']."price has changed";
                        break;
                    }
                    
                    $cost_of_actual_product =    $get_product->product_price      * (int)$value['product_quantity'];
                    
                    $total_amount_from_backend += $cost_of_actual_product;
                    
                    $cost_of_product = (int)$value['product_price'] * (int)$value['product_quantity'];
                    
                    $total_amount_from_app += $cost_of_product;
                }
                if($message){
                     return response()->json([
                         "status"=>"failed",
                        "message"=> $message
                        ]);
                }
                elseif($total_amount_from_app == $total_amount_from_backend){
                     Customer_transaction::where('customer_id', $customer->id)->where('transaction_status', false)->delete();
                     $get_id=Customer_transaction::create([
                     "items_bought"=> $serilize_product,
                     "total_amount"=> $total_amount_from_app,
                     "customer_id"=>  $customer->id,
                     
                     "date"=>$date,
                    "time"=>$time,
                    "transaction_status"=>false
                    ]);
                    
                    return response()->json([
                        "cart_id"=> $get_id->id,
                        "status"=>"success",
                        "total_amount_to_pay"=>$total_amount_from_backend
                        ]);
                }else{
                       return response()->json([
                        "status"=>"failed",
                        "total_amount_to_pay"=>$total_amount_from_backend
                        ]);
                }
                
            }
    }
//verify paystack transactions
    public function verify_payments(Request $request){
        
            $validator = Validator::make($request->all(), [
                'cart_id'=>'required',
                 'reference'=> 'required',
            ]);
        
        
        
         if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
      
    $reference=$request->reference;
     $curl = curl_init();
  curl_setopt_array($curl, array(
    CURLOPT_URL => "https://api.paystack.co/transaction/verify/{$reference}",
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
      "Authorization: sk_test_78d3222355597d8e13ada75b3f02230f6849d4d8",
      "Cache-Control: no-cache",
    ),
  ));
  //test key
  //sk_test_78d3222355597d8e13ada75b3f02230f6849d4d8
 //live paystack key
// sk_live_75cd2aea916edd58b62c7dad9ec24f1be553f393
  $response = curl_exec($curl);
  $err = curl_error($curl);
  curl_close($curl); 
  
  $result= json_decode($response);
  
  if($result->status=true){
     $token = JWTAuth::parseToken()->getPayload()->toArray();
                $id=$token['id'];
                
                 $customer=User::where('id',$id)->first();
                $encoded_products= Customer_transaction::where('id', $request->cart_id)->first();
                if($encoded_products){
                    Customer_transaction::where('id', $request->cart_id)->update([
                       "transaction_status"=>true
                        ]);
                
                $decoded_product= json_decode($encoded_products->items_bought);
                $serilize_product= serialize($decoded_product);
                $carbondate=Carbon::now();
                $date = $carbondate->toDateString();
                $time= $carbondate->now('UTC')->setTimezone('WAT')->format('g:i:s a');
                
                $total_amount = 0;
                
                foreach($decoded_product as $value){
                    $cost_of_product = (int)$value->product_price * (int)$value->product_quantity;
                    $total_amount += $cost_of_product;
                }
                
                foreach($decoded_product as $product){
                    
                    Orders::create([
                          "product_name"=>$product->product_name,
                          "product_id"=>$product->product_id,
                          "product_price"=>$product->product_price,
                          "image_url"=>$product->image_url,
                          "amount_ordered"=>$product->product_quantity,
                          "owner_id"=>$product->owner_id,
                          "shipping_phone_number"=>$product->phone_number,
                          "customer_name"=>$customer->name,
                          "customer_id"=>$customer->id,
                          "state"=>$product->state,
                          "destination_address"=>$product->destination_address,
                          "date"=>$date,
                          "time"=>$time
                    ]); 
                    
                    
                    $superadmin = Superadmin::first();
                    $commission = $superadmin->super_admin_commission;
                    $owner_id=$product->owner_id;
                    $id=$product->product_id;
                    $quantity=$product->product_quantity;
                $product_price= (int)$product->product_quantity *  (int)$product->product_price;
                
                 $commission_on_product = $product_price * (int)$commission;
                $amount_for_Wallet = (int)$product_price - (int)$commission_on_product;
                Admin::where('id',$owner_id)->increment('wallet',$amount_for_Wallet);
                
                Products::where('id',$id)->decrement('product_quantity',$quantity);
                $admin_detail = Admin::where('id',$owner_id)->first();
                $check_order_exist = Orders::where('owner_id',$product->owner_id)->where('date',$date)->where('time',$time)->count();
                
                if($check_order_exist == 1){
                     $title = "New Order";
                     //seller
                     $customer_title = "Order Receipt";
                     $customer_info = [
                         "customer_name"=>$customer->name,
                         "email"=>$customer->email,
                         "superadmin_phone_number"=>$superadmin->phone_number,
                         "superadmin_email"=>$superadmin->email
                         ];
                     $order_transaction_details =[
                            "items_bought"=>$decoded_product,
                            "total"=> $encoded_products->total_amount,
                            "subtotal"=> $encoded_products->total_amount,
                            "delivery_fee"=> "Free",
                            "state"=>$product->state,
                            "address"=>$product->destination_address
                            
                         ];
                         
                         
                     $admins_info=[
                         "name"=>$admin_detail->company_name,
                         "email"=>$admin_detail->email
                         ];
                         $transaction_details=["type"=>""];
                     $number = $admin_detail->company_phone_number;
                     $name = $admin_detail->company_name;
                     //super admin
                     $superadmin_info=[
                         "name"=> $superadmin->name,
                         "email"=>$superadmin->email,
                         ];
                       
                     $superadmin_name =  $superadmin->name;
                     $superadmin_number =  $superadmin->phone_number;
                     $this->send_otp($name, $number);
                     
                     $this->send_otp($superadmin_name, $superadmin_number);
                     
                     dispatch(new Sendorderalert($title,$admins_info,$transaction_details));
                     
                     dispatch(new Sendorderalert($title,$superadmin_info,$transaction_details));
                     
                      dispatch(new Orderreceipt($customer_title,$customer_info,$order_transaction_details));
                     
                 }
                
                }
                
               
                
                
                   Notification::create([
                         "notification_date"=>$date,
                         "notification_name"=>$customer->name ." "."just order",
                         "notification_type"=>"order",
                         "notification_id"=>$customer->id,
                         "owner_id"=>$product->owner_id
                       ]);
                       
                       
            return response()->json(
                [ "status"=>"success","message"=>"order has been created"]
                );}
  }
            }
  
     
    }
 
    
//get customer order history
 public function order_history(){
         $token = JWTAuth::parseToken()->getPayload()->toArray();
                    $id=$token['id'];
            $orders=  Customer_transaction::where('customer_id',$id)->get();
            
       
                
               $data =[];
            foreach($orders as $value){
                    $unserialize_orders= unserialize($value->items_bought);
                      
                    $array40 = [
                        "id"=> $value->id,
                        "product"=>$unserialize_orders,
                        "total_amount"=> $value->total_amount,
                        "delivery"=>$value->status,
                        "date"=>$value->date,
                        "time"=>$value->time
                        ]; 
                        
                        array_push($data, $array40);
                     
                           
            }
            
           
            return response()->json($data);
 }
    
    
    
    //get mechanic history
    public function get_mechanic_history(){
             $token = JWTAuth::parseToken()->getPayload()->toArray();
                    $id=$token['id'];
                    
                    $get_agent = Book_agent::where('user_id',$id)->get();
                    $final_array= [];
                    foreach($get_agent as $value){
                          $service_agent =  Service_agent::where('id', $value->mechanic_id)->first();
                          $array23=[
                              "id"=>$service_agent->id,
                              "name"=> $service_agent->name,
                              "phone_number"=> $service_agent->phone_number,
                              "working_time"=> $service_agent->working_time,
                              "lat"=> $service_agent->lat,
                              "log"=> $service_agent->log,
                              "category"=>$service_agent->category,
                              "working_time"=>$service_agent->working_time,
                              "bio"=>$service_agent->bio,
                              "experience"=>$service_agent->experience,
                              "rating"=>$service_agent->ratings,
                              "email"=>$service_agent->email,
                              "date"=>$value->date,
                              "time"=>$value->time
                              
                              ];
                          array_push($final_array, $array23);
                    }
                 $array1 = $this->paginate($final_array);
                  return response()->json($array1);
                  
    }
    //review ordered product
    
    public function review_ordered_product(Request $request){
                 
                 
                 $token = JWTAuth::parseToken()->getPayload()->toArray();
                    $id=$token['id'];
                    $reviews = $request->review;
                    $ratings = $request->rating;
                    $product_id = $request->product_id;
                    $review = Product_review::where('product_id', $product_id )->where('user_id',$id)->first();
                    if($review){
                         return response()->json([
                            "status"=>"failed",
                            "message"=>"You already have a review for  this product"
                           ]);
                    }else{
                         Product_review::create([
                          "ratings"=> $ratings,
                          "reviews"=>$reviews,
                          "user_id"=>$id,
                          "product_id"=>$product_id
                        ]);
                        
                        return response()->json([
                            "status"=>"success"
                           ]);
                    }
                   
    }
    
    // public function update_ordered_product_review(Request $request){
    //                 $token = JWTAuth::parseToken()->getPayload()->toArray();
    //                 $id=$token['id'];
    //         $validator = Validator::make($request->all(), [
    //             'ratings' => 'required|string|max:255',
    //             'reviews'=>'required',
    //             'product_id'=>'required',
             
    //         ]);

    //         if($validator->fails()){
    //                 return response()->json($validator->errors(), 400);
    //         }else{
    //             Product_review::where('user_id',$id)->update([
    //                       "ratings"=>$request->ratings,
    //                       "reviews"=>$request->reviews,
    //                       "product_id"=>$request->product_id,
    //                       "user_id"=>$id
    //                 ]);
                    
    //             return response()->json([
    //                 "status"=>"success",
    //                 "message"=>"review updated"
    //                 ]);
    //         }
    // }
    
    public function delete_review(Product_review $product_review){
                    $product_review->delete();
                    
                return response()->json([
                    "status"=>"success",
                    "message"=>"review deleted"
                    ]);
                    
                    
    }
    
    
    
}