<?php

namespace App\Http\Controllers;
use App\Models\Dtc_interpretation;
use App\Models\Scanned_data;
use App\Models\User;


use Illuminate\Http\Request;

use Illuminate\Support\Facades\Validator;
use JWTAuth;

class Scancontroller extends Controller
{    
    
    //store scaned data
   public function input_scaned_data(Request $request){
    $validator = Validator::make($request->all(),[
        'date_time'=>'required',
        'rpm'=>'required',
        'engine_load'=>'required',
        'device_id'=>'required',
        'speed'=>'required',
        'intake_temp'=>'required',
        'coolant_temp'=>'required',
        'throttle'=>'required',
        'batteryvoltage'=>'required',
        'lat'=>'required',
        'log'=>'required'
                
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
               
                Scanned_data::create([
                    "date_time"=> $request->input('date_time'),
                    "rpm"=>$request->input('rpm'),
                    "engine_load"=>$request->input('engine_load'),
                    "timestamp"=>$request->input('date_time'),
                    "deviceid"=>$request->input('device_id'),
                    "speed"=>$request->input('speed'),
                    "intake_temp"=>$request->input('intake_temp'),
                    "coolant_temp"=>$request->input('coolant_temp'),
                    "throttle"=>$request->input('throttle'),
                    "batteryvoltage"=>$request->input('batteryvoltage'),
                    "dtc"=>$request->input('dtc'),
                    "lat"=>$request->input('lat'),
                    "log"=>$request->input('log'),
                    ]);
                    
                    return response()->json([
                        "status"=>"success"
                        ]);
            }
    }
    //automatic scan
    public function get_scaned_data_at_intervals(){
              $token = JWTAuth::parseToken()->getPayload()->toArray();
                    $id=$token['id'];
                    
            $get_device_id = User::where('id', $id)->first();
            
           $scanned_data = Scanned_data::select('intake_temp','engine_load','batteryvoltage','coolant_temp','rpm','speed','lat','log')->where('deviceid',  $get_device_id->device_id)->orderBy('id', 'desc')->first();
           
           return response()->json(
                 $scanned_data);
            
    }
    //manual scan
    public function get_manual_scaned_data(){
               
               
               $token = JWTAuth::parseToken()->getPayload()->toArray();
                    $id=$token['id'];
                    
            $get_device_id = User::where('id', $id)->first();
            
           $scanned_data = Scanned_data::select('dtc','intake_temp','engine_load','batteryvoltage','coolant_temp','rpm','speed')->where('deviceid',  $get_device_id->device_id)->orderBy('id', 'desc')->first();
               
               
               
              $dtc_string = $scanned_data->dtc;
              
              
$dtc_string = preg_replace('/\.$/', '', $dtc_string); //Remove dot at end if exists
$array = explode(', ', $dtc_string); //split string into array seperated by ', '
$dtc= [];


foreach($array as $value) //loop over values
{       
    
    $interpretation = Dtc_interpretation::where('fault_code', $value)->first();
    
    if($interpretation)
    {
    $array2 = [
        "fault_code" => $value,
        "fault_definition"=> $interpretation->fault_definition,
        "fault_meaning"=> $interpretation->fault_meaning,
        "fault_causes"=>$interpretation->fault_causes,
        "symptoms"=> $interpretation->symptoms,
        "diagnosis"=> $interpretation->diagnosis,
        "fault_level"=>$interpretation->fault_level,
        "fault_repairs"=> $interpretation->fault_repairs
        ];
        
    array_push($dtc, $array2);
} 
}

return response()->json([
             "intake_temp"=>  $scanned_data->intake_temp,
             "speed"=>  $scanned_data->speed,
             "coolant_temp"=>  $scanned_data->coolant_temp,
             "engine_load"=>  $scanned_data->engine_load,
             "rpm"=>  $scanned_data->rpm,
             "batteryvoltage"=>  $scanned_data->batteryvoltage,
             "dtc"=>  $dtc
    ]);

    }
    //update password from dashboard
    
    public function update_password_from_dashboard(Request $request){
               $validator = Validator::make($request->all(), [
                'password' => 'required|string|min:6|confirmed',
                'old_password'=>'required'
                
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                 $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                   
                 $user= User::where('id', $id)->first();
                $pass=$user->password;
                if(Hash::check($request->old_password, $pass)){
                    
                $id=$user->id;
           
            $admin = Student::where('id',$id)->update([
                'password'=>Hash::make($request->password)
            ]);
            return response()->json(["status"=>"success"],200);
                }else{
                    return response()->json([
                        "satus"=> "failed",
                        "message"=>"Incorrect password"
                        ]);
                }
                
                }
}
    
    public function get_all_dtcmeaning(Request $request){
        $interpretation = Dtc_interpretation::paginate(10);
        
         return response()->json($interpretation); 
    }
    
    public function upload_dtc(Request $request){
         $validator = Validator::make($request->all(),[
        'dtc_code'=>'required',
        'dtc_meaning'=>'required',
        'description'=>'required',
        'possible_cause'=>'required',
       
                
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }
              
              else{
                $interpretation = Dtc_interpretation::where('dtc_code', $request->dtc_code)->first();
                if($interpretation){
                     return response()->json([
                        "satus"=> "failed",
                        "message"=>"code already exist"
                        ]);
                }else{
                    Dtc_interpretation::create([
                        "dtc_code"=> $request->dtc_code,
                        "dtc_meaning"=>$request->dtc_meaning,
                        "description"=> $request->description,
                        "possible_cause"=> $request->possible_cause
                        ]);
                        
                        return response()->json(["status"=>"success"],200);
                }
                }
    
    
    }
    

}