<?php

namespace App\Http\Controllers;
use App\Models\User;

use App\Models\Notification;
use App\Models\Scanned_data;

use App\Models\Agent_rating;
use App\Models\Book_agent;
use App\Models\Dtc_interpretation;
use App\Models\Service_agent;

use Illuminate\Support\Collection;


use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use App\Mail\Sendotp;
use Illuminate\Support\Facades\Mail;
use JWTAuth;
use Config;
use Auth;
use Carbon\Carbon;
use Tymon\JWTAuth\Exceptions\JWTException;
class Serviceagentcontroller extends Controller
{
    
    public function register_service_agent(Request $request){
             $validator = Validator::make($request->all(), [
                'name' => 'required|string|max:255',
                'email' => 'required|string|email|max:255|unique:service_agent',
                'phone_number'=>'required|unique:service_agent',
                'password' => 'required|string|min:6|confirmed',
                'experience'=>'required',
                'category'=>'required',
                'working_time'=>'required',
                
            ]);

            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
             $user = Service_agent::create([
                'name' => $request->name,
                'email' => $request->email,
                'phone_number'=>$request->phone_number,
                'experience'=> $request->experience,
                'category'=> $request->category,
                'working_time'=> $request->working_time,
                'password' => Hash::make($request->get('password')),
            ]);
            $userid=$user->id;
            $get_user= Service_agent::where('id',$userid)->first();
             $payload=[
                 "name"=>$user->name,
                 "role"=>$get_user->role,
                 "id"=>$user->id
                 ];
          
            return response()->json(["status"=>"success"],201);
            }
    }
    
    public function login_service_agent(Request $request){
         // Config::set('jwt.user', 'App\Models\Admin');
            // Config::set('auth.providers.users.model', \App\Models\Admin::class); 
            $credentials = $request->only('email', 'password');
             

            try {

                auth()->shouldUse('serviceagent_api');
                
                if(JWTAuth::attempt($credentials)){
                   $authuser=auth()->guard('serviceagent_api')->user();
                   
                  
                
                   if($authuser->active == false){
                       return response()->json([
                           "status"=>"failed",
                           "message"=>"your account have been suspended"
                           ]);
                   }else{
                         $payload=[
                        "name"=>$authuser->name,
                        "role"=>$authuser->role,
                        "id"=>$authuser->id
                        ];
                        
                    $token=JWTAuth::customClaims($payload)->fromUser($authuser);
                   }
                  
                }
                else {
                    return response()->json(['error' => 'invalid_credentials'], 400);
                }
            } catch (JWTException $e) {
                return response()->json(['error' => 'could_not_create_token'], 500);
            }
             $expirein=  config('jwt.ttl');
            return response()->json(["user"=>auth()->guard('serviceagent_api')->user(),"expirein"=>$expirein,"token"=>$token]);
    }
    
    
    public function dashboard_api_for_service_agent(){
     $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                   
       $user= Service_agent::select('working_time','id','email','phone_number','experience','bio','ratings')->where('id', $id)->first();
       
       $total_booking = Book_agent::where('mechanic_id', $id)->count();
       $total_unaccepted_bookings = Book_agent::where('mechanic_id', $id)->where('status', false)->count();
      
       
       return response()->json([
           "total_booking"=> $total_booking,
           "total_unaccepted_bookings"=>$total_unaccepted_bookings,
           "id" => $user->id,
           "email"=>$user->email,
           "phone_number"=> $user->phone_number,
           "experience"=> $user->experience,
           "bio"=> $user->bio,
           "ratings"=> $user->ratings,
           "working_time"=>$user->working_time
           ]);
}

    
    public function agent_confirm_email(Request $request){
    
            $validator = Validator::make($request->all(),[
                'email' => 'required|string|email|max:255',
                
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                $email=$request->email;
                $user_details= Service_agent::where('email',$email)->first();
              
                if($user_details){
                    $otp_gen=random_int(1000, 9999);
                     
                    $carbondate=Carbon::now();
                    //Foo::whereBetween('created_at', [now()->subMinutes(3), now()])->get()
                    $datetime= $carbondate->toDateTimeString();
   
                    
                    Service_agent::where('email',$email)->update([
                        "otp"=>$otp_gen,
                        "otp_date_time"=>$datetime
                        ]);
                     $title="otp from obd2";
                     $customer_info=[
                         "name"=>$user_details->name,
                         "email"=>$user_details->email
                         ];
                     $otp=[
                         "otp"=>$otp_gen
                         ];
                    $sendmail= Mail::to( $customer_info['email'])->send(new Sendotp($title,$customer_info,$otp));
                   
                    if(empty($sendmail)){
                      return response()->json([
                     "status"=>"success",
                     "email"=> $user_details->email,
                     "message"=>"user exist"
                    ]);
                    }
                    
                }else{
                    
                    return response()->json([
                        "status"=>"failed",
                        "message"=>"user does not exist"
                        
                        ]);
                }
               
                
            }
        
}
//verify otp
public function agent_verify_otp(Request $request){
    
            $validator = Validator::make($request->all(),[
                'email' => 'required|string|email|max:255',
                'otp'=>'required'
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                 $otp=$request->otp;
                $email=$request->email;
                    $carbondate=Carbon::now();
                    $otp_check= Service_agent::where('email',$email)->where('otp',$otp)->where('otp_date_time', '>', $carbondate->subMinutes(5)->format('Y-m-d H:i:s'))->first();
                  
                    if($otp_check){
                         return response()->json([
                            "status"=>"success",
                            "message"=>"otp verified"
                            ]);
                        
                    }else{
                        return response()->json([
                            "status"=>"failed",
                            "message"=>"otp expired"
                            ]);
                    } 
            }
              
}
//reset password
  public function  agent_reset_password(Request $request){
                $validator = Validator::make($request->all(), [
                'email'=>'required',
                'password' => 'required|string|min:6|confirmed'
            ]);

            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                $email=$request->email;
                Service_agent::where('email',$email)->update([
                    "password"=> Hash::make($request->get('password')),
                    ]);
                    
                return response()->json([
                    "status"=>"success",
                    "message"=>"updated successfully"
                    ]);
            }
  }
    
    
    //update service agent details
    public function update_service_agent_details(Request $request){
                 $validator = Validator::make($request->all(), [
                'name' => 'required|string|max:255',
                'bio' => 'required|string',
                'experience'=>'required',
                'working_time'=>'required',
            ]);

            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                   $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                Service_agent::where('id', $id)->update([
                    "name"=> $request->name,
                    "bio"=> $request->bio,
                    "experience"=> $request->experience,
                    "working_time"=> $request->working_time
                    ]);
                    
                return response()->json([
                          "status"=>"success",
                          "message"=>"Updated successfully"
                    ]);
            }
    }
    
    
    public function update_password_from_dashboard(Request $request){
                $validator = Validator::make($request->all(), [
                'password' => 'required|string|min:6|confirmed',
                'old_password'=>'required'
                
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                 $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                   
                 $user=  Service_agent::where('id', $id)->first();
                $pass=$user->password;
                if(Hash::check($request->old_password, $pass)){
                    
                $id=$user->id;
           
            $admin =  Service_agent::where('id',$id)->update([
                'password'=>Hash::make($request->password)
            ]);
            return response()->json(["status"=>"success"],200);
                }else{
                    return response()->json([
                        "satus"=> "failed",
                        "message"=>"Incorrect password"
                        ]);
                }
                
                }
    }
    
    public function get_agent_bookings(Request $request){
            
                 $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                
                  
                   
                  $result= Book_agent::where('mechanic_id', $id)->get();
                  $array1=[];
                  foreach($result as $data){
                      $users = User::where('id', $data->user_id)->first();
                       $scanned_data = Scanned_data::select('id','dtc')->where('deviceid',$users->device_id )->orderBy('id', 'desc')->first();
                       
                       
                     if($scanned_data)  {  
                         
                          $dtc_string = $scanned_data->dtc;
$dtc_string = preg_replace('/\.$/', '', $dtc_string); //Remove dot at end if exists
$array = explode(', ', $dtc_string); //split string into array seperated by ', '
$dtc= [];


foreach($array as $value) //loop over values
{       
    
    $interpretation = Dtc_interpretation::where('dtc_code', $value)->first();
    
    if($interpretation)
    {
    $array2 = [
        "error_code" => $value,
        "code_meaning"=> $interpretation->dtc_meaning,
        "description"=> $interpretation->description,
        "possible_cause"=>$interpretation->possible_cause
        ];
        
    array_push($dtc, $array2);
} 
}}
                      $array2 = [
                          "id"=>$data->id,
                          "name"=> $users->name,
                          "date"=> $data->date,
                          "time"=>$data->time,
                          "lat"=>$data->lat,
                          "log"=>$data->log,
                          "status"=> $data->status,
                          "phone_number"=> $users->phone_number,
                          "scanned_result"=> $dtc
                          ];
                     
                     array_push($array1, $array2);
                  }
                     return response()->json($array1);
                
                
                
               
            
    }
    
    public function decline_request(Request $request){
         $validator = Validator::make($request->all(), [
                'booking_id'=>'required'
                
            ]);
            if($validator->fails()){
                    return response()->json($validator->errors(), 400);
            }else{
                $token = JWTAuth::parseToken()->getPayload()->toArray();
                   $id=$token['id'];
                $check =  Book_agent::where('id', $request->booking_id)->where('mechanic_id', $id)->first();
                if($check){
                Book_agent::where('id', $request->booking_id)->update([
                    "status"=> true
                    ]);
                    
                    return response()->json([
                        "status"=> "success"
                        ]);
                }else{
                    return response()->json([
                        "status"=> "failed"
                        ]);
                }   
                
            }
    }
    
}