<?php

namespace App\Listeners;
use App\Models\Agent;
use App\Events\NewRequestEvent;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Queue\InteractsWithQueue;
use Carbon\Carbon;
class AssignRequestListener implements ShouldQueue
{
    use InteractsWithQueue;

    /**
     * Handle the event.
     *
     * @param NewRequestEvent $event
     * @return void
     */
    public function handle(NewRequestEvent $event)
    {
        $request = $event->request;
         $date = Carbon::now();
        // Check if request remains unassigned after 60 seconds using Carbon
        if ($date->diffInSeconds($request->assigned_at) >= 60) {
            $getagent;
          Agent::where("id", $request->agent_id)->update([
              "status"=>"offline"
              ]);
            // Reassign request to another available agent
           $getagent = Agent::where("account_disabled", 1)->where("status","online")->inRandomOrder()->first();
           
           if(!$getagent){
                 $getagent = Agent::where("account_disabled", 1)->where("status","busy")->inRandomOrder()->first();
           }
    
            $request->update(['assigned_to' => $getagent->id, 'assigned_at' => $date]);
        }
    }
}