<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Authcontroller;

use App\Http\Controllers\Adsresponders;

use App\Http\Controllers\Agentcontroller;

use App\Http\Controllers\Devicecontroller;


/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/



//
Route::post('login',[Authcontroller::class, 'login']);


Route::group(['middleware'=>['auth.role:admin']], function(){
    
    //create devices
Route::post('createdevices', [Devicecontroller::class, 'register_device']);

//update device
Route::post('updatedevices', [Devicecontroller::class, 'update_device_details']);

//create responder
Route::post('create_responder', [Adsresponders::class, 'create_responder']);

//update responder
Route::post('update_responder', [Adsresponders::class, 'update_responder']);

//responder details 
Route::get('responder_details', [Adsresponders::class, 'responder_details']);


//get agents
Route::get('get_agents', [Agentcontroller::class, 'get_all_agent']);

//create agent
Route::post('create_agents', [Agentcontroller::class, 'create_agent']);


//update agent
Route::post('update_agent', [Agentcontroller::class, 'update_agent']);
});


//device heart beat
 Route::post('create_heart_beat',[Devicecontroller::class, 'heart_beat']);

Route::group(['middleware'=>['auth.role:general']], function(){
    
    Route::get('dashboard_api',[Authcontroller::class, 'dashboard_api_for_user']);
    
    Route::get('get_device_details',[Devicecontroller::class, 'get_device_details']);
    
    //get responder
Route::get('get_responder', [Adsresponders::class, 'get_responders']);
});


// Route::group(['middleware'=>['auth.role:agent,admin' ]], function(){
    
    

  
// });

//get agent details
Route::get('get_agent_details',[Agentcontroller::class, 'agent_details']);

Route::group(['middleware'=>['auth.role:agent']], function(){
    
    Route::post('assign_accident',[Agentcontroller::class, 'assign_accident']);
    
     //get responder
Route::get('accept', [Agentcontroller::class, 'accept_request']);
    
});

//post accident detected
Route::post('post_accident_detected',[Devicecontroller::class, 'accident_detection']);



//get devices
Route::get('get_devices',[Devicecontroller::class, 'get_all_devices']);



